# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "11" />
#<program4xi program = "buffer4xi5test.py">
#<abstract4xi abstract = "tests buffer4xi"/>
#<verify4xi verification = "11" target = "buffer4xi5test.py"/>
#<contextualize4xi context = "buffer4xi.py"/>
#<use4xi usage = "
# SET:
# 
# RUN:
# > python buffer4xi5test.py > E:\scope4xi\041721\zap\work\txt\buffer4xi5test.txt
#
# ANALYZE:
#
# sense-test-buffer4xi5test.xml     <-- trace in XML
# reason-test-buffer4xi5test.xml
# ace-test-buffer4xi5test.xml
# buffer4xi5test.txt                <-- OF BUFFER4XI5TEST
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = [ 'buffer4xi5test']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  

from ctypes import Structure, c_double

#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from arena4xi import Arena4Xi
from queue4xi import Queue4Xi                                                                                      

from platformids4xi import get2platformids4xi


# -------------------------------------------------------------------------------------------------
# Buffer modules                           
# -------------------------------------------------------------------------------------------------
from buffer4xi import Buffer4Xi
from buffer4xi import create2buffer4xi
from buffer4xi import create2subbuffer4xi
from buffer4xi import get2bufferinfo4xi
from buffer4xi import release2buffer4xi
from buffer4xi import retain2buffer4xi
from buffer4xi import set2buffer4xi

from apu2buffer4xi import APU2Buffer4Xi                                                                 
from bpu2buffer4xi import BPU2Buffer4Xi
from cpu2buffer4xi import CPU2Buffer4Xi
from dpu2buffer4xi import DPU2Buffer4Xi
from epu2buffer4xi import EPU2Buffer4Xi
from fpu2buffer4xi import FPU2Buffer4Xi
from gpu2buffer4xi import GPU2Buffer4Xi
from hpu2buffer4xi import HPU2Buffer4Xi
from ipu2buffer4xi import IPU2Buffer4Xi
from jpu2buffer4xi import JPU2Buffer4Xi
from kpu2buffer4xi import KPU2Buffer4Xi
from lpu2buffer4xi import LPU2Buffer4Xi
from mpu2buffer4xi import MPU2Buffer4Xi
from npu2buffer4xi import NPU2Buffer4Xi
from opu2buffer4xi import OPU2Buffer4Xi
from ppu2buffer4xi import PPU2Buffer4Xi
from qpu2buffer4xi import QPU2Buffer4Xi
from rpu2buffer4xi import RPU2Buffer4Xi
from spu2buffer4xi import SPU2Buffer4Xi
from tpu2buffer4xi import TPU2Buffer4Xi
from upu2buffer4xi import UPU2Buffer4Xi
from vpu2buffer4xi import VPU2Buffer4Xi
from xpu2buffer4xi import XPU2Buffer4Xi
from wpu2buffer4xi import WPU2Buffer4Xi
from ypu2buffer4xi import YPU2Buffer4Xi
from zpu2buffer4xi import ZPU2Buffer4Xi


from apu2buffer4xi import create2buffer4apu
from bpu2buffer4xi import create2buffer4bpu
from cpu2buffer4xi import create2buffer4cpu
from dpu2buffer4xi import create2buffer4dpu
from epu2buffer4xi import create2buffer4epu
from fpu2buffer4xi import create2buffer4fpu
from gpu2buffer4xi import create2buffer4gpu
from hpu2buffer4xi import create2buffer4hpu
from ipu2buffer4xi import create2buffer4ipu
from jpu2buffer4xi import create2buffer4jpu
from kpu2buffer4xi import create2buffer4kpu
from lpu2buffer4xi import create2buffer4lpu
from mpu2buffer4xi import create2buffer4mpu
from npu2buffer4xi import create2buffer4npu
from opu2buffer4xi import create2buffer4opu
from ppu2buffer4xi import create2buffer4ppu
from qpu2buffer4xi import create2buffer4qpu
from rpu2buffer4xi import create2buffer4rpu
from spu2buffer4xi import create2buffer4spu
from tpu2buffer4xi import create2buffer4tpu
from upu2buffer4xi import create2buffer4upu
from vpu2buffer4xi import create2buffer4vpu
from xpu2buffer4xi import create2buffer4xpu
from wpu2buffer4xi import create2buffer4wpu
from ypu2buffer4xi import create2buffer4ypu
from zpu2buffer4xi import create2buffer4zpu


from apu2buffer4xi import create2subbuffer4apu 
from bpu2buffer4xi import create2subbuffer4bpu 
from cpu2buffer4xi import create2subbuffer4cpu 
from dpu2buffer4xi import create2subbuffer4dpu 
from epu2buffer4xi import create2subbuffer4epu 
from fpu2buffer4xi import create2subbuffer4fpu 
from gpu2buffer4xi import create2subbuffer4gpu 
from hpu2buffer4xi import create2subbuffer4hpu 
from ipu2buffer4xi import create2subbuffer4ipu 
from jpu2buffer4xi import create2subbuffer4jpu 
from kpu2buffer4xi import create2subbuffer4kpu 
from lpu2buffer4xi import create2subbuffer4lpu 
from mpu2buffer4xi import create2subbuffer4mpu 
from npu2buffer4xi import create2subbuffer4npu 
from opu2buffer4xi import create2subbuffer4opu 
from ppu2buffer4xi import create2subbuffer4ppu 
from qpu2buffer4xi import create2subbuffer4qpu 
from rpu2buffer4xi import create2subbuffer4rpu 
from spu2buffer4xi import create2subbuffer4spu 
from tpu2buffer4xi import create2subbuffer4tpu 
from upu2buffer4xi import create2subbuffer4upu 
from vpu2buffer4xi import create2subbuffer4vpu 
from xpu2buffer4xi import create2subbuffer4xpu 
from wpu2buffer4xi import create2subbuffer4wpu 
from ypu2buffer4xi import create2subbuffer4ypu 
from zpu2buffer4xi import create2subbuffer4zpu 

from apu2buffer4xi import get2bufferinfo4apu
from bpu2buffer4xi import get2bufferinfo4bpu
from cpu2buffer4xi import get2bufferinfo4cpu
from dpu2buffer4xi import get2bufferinfo4dpu
from epu2buffer4xi import get2bufferinfo4epu
from fpu2buffer4xi import get2bufferinfo4fpu
from gpu2buffer4xi import get2bufferinfo4gpu
from hpu2buffer4xi import get2bufferinfo4hpu
from ipu2buffer4xi import get2bufferinfo4ipu
from jpu2buffer4xi import get2bufferinfo4jpu
from kpu2buffer4xi import get2bufferinfo4kpu
from lpu2buffer4xi import get2bufferinfo4lpu
from mpu2buffer4xi import get2bufferinfo4mpu
from npu2buffer4xi import get2bufferinfo4npu
from opu2buffer4xi import get2bufferinfo4opu
from ppu2buffer4xi import get2bufferinfo4ppu
from qpu2buffer4xi import get2bufferinfo4qpu
from rpu2buffer4xi import get2bufferinfo4rpu
from spu2buffer4xi import get2bufferinfo4spu
from tpu2buffer4xi import get2bufferinfo4tpu
from upu2buffer4xi import get2bufferinfo4upu
from vpu2buffer4xi import get2bufferinfo4vpu
from xpu2buffer4xi import get2bufferinfo4xpu
from wpu2buffer4xi import get2bufferinfo4wpu
from ypu2buffer4xi import get2bufferinfo4ypu
from zpu2buffer4xi import get2bufferinfo4zpu


from apu2buffer4xi import release2buffer4apu
from bpu2buffer4xi import release2buffer4bpu
from cpu2buffer4xi import release2buffer4cpu
from dpu2buffer4xi import release2buffer4dpu
from epu2buffer4xi import release2buffer4epu
from fpu2buffer4xi import release2buffer4fpu
from gpu2buffer4xi import release2buffer4gpu
from hpu2buffer4xi import release2buffer4hpu
from ipu2buffer4xi import release2buffer4ipu
from jpu2buffer4xi import release2buffer4jpu
from kpu2buffer4xi import release2buffer4kpu
from lpu2buffer4xi import release2buffer4lpu
from mpu2buffer4xi import release2buffer4mpu
from npu2buffer4xi import release2buffer4npu
from opu2buffer4xi import release2buffer4opu
from ppu2buffer4xi import release2buffer4ppu
from qpu2buffer4xi import release2buffer4qpu
from rpu2buffer4xi import release2buffer4rpu
from spu2buffer4xi import release2buffer4spu
from tpu2buffer4xi import release2buffer4tpu
from upu2buffer4xi import release2buffer4upu
from vpu2buffer4xi import release2buffer4vpu
from xpu2buffer4xi import release2buffer4xpu
from wpu2buffer4xi import release2buffer4wpu
from ypu2buffer4xi import release2buffer4ypu
from zpu2buffer4xi import release2buffer4zpu

from apu2buffer4xi import retain2buffer4apu
from bpu2buffer4xi import retain2buffer4bpu
from cpu2buffer4xi import retain2buffer4cpu
from dpu2buffer4xi import retain2buffer4dpu
from epu2buffer4xi import retain2buffer4epu
from fpu2buffer4xi import retain2buffer4fpu
from gpu2buffer4xi import retain2buffer4gpu
from hpu2buffer4xi import retain2buffer4hpu
from ipu2buffer4xi import retain2buffer4ipu
from jpu2buffer4xi import retain2buffer4jpu
from kpu2buffer4xi import retain2buffer4kpu
from lpu2buffer4xi import retain2buffer4lpu
from mpu2buffer4xi import retain2buffer4mpu
from npu2buffer4xi import retain2buffer4npu
from opu2buffer4xi import retain2buffer4opu
from ppu2buffer4xi import retain2buffer4ppu
from qpu2buffer4xi import retain2buffer4qpu
from rpu2buffer4xi import retain2buffer4rpu
from spu2buffer4xi import retain2buffer4spu
from tpu2buffer4xi import retain2buffer4tpu
from upu2buffer4xi import retain2buffer4upu
from vpu2buffer4xi import retain2buffer4vpu
from xpu2buffer4xi import retain2buffer4xpu
from wpu2buffer4xi import retain2buffer4wpu
from ypu2buffer4xi import retain2buffer4ypu
from zpu2buffer4xi import retain2buffer4zpu


from apu2buffer4xi import set2buffer4apu
from bpu2buffer4xi import set2buffer4bpu
from cpu2buffer4xi import set2buffer4cpu
from dpu2buffer4xi import set2buffer4dpu
from epu2buffer4xi import set2buffer4epu
from fpu2buffer4xi import set2buffer4fpu
from gpu2buffer4xi import set2buffer4gpu
from hpu2buffer4xi import set2buffer4hpu
from ipu2buffer4xi import set2buffer4ipu
from jpu2buffer4xi import set2buffer4jpu
from kpu2buffer4xi import set2buffer4kpu
from lpu2buffer4xi import set2buffer4lpu
from mpu2buffer4xi import set2buffer4mpu
from npu2buffer4xi import set2buffer4npu
from opu2buffer4xi import set2buffer4opu
from ppu2buffer4xi import set2buffer4ppu
from qpu2buffer4xi import set2buffer4qpu
from rpu2buffer4xi import set2buffer4rpu
from spu2buffer4xi import set2buffer4spu
from tpu2buffer4xi import set2buffer4tpu
from upu2buffer4xi import set2buffer4upu
from vpu2buffer4xi import set2buffer4vpu
from xpu2buffer4xi import set2buffer4xpu
from wpu2buffer4xi import set2buffer4wpu
from ypu2buffer4xi import set2buffer4ypu
from zpu2buffer4xi import set2buffer4zpu



# -------------------------------------------------------------------------------------------------
# Context modules                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi                                                                                 
from context4xi import create2context4xi                                                                         
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi                                                                             
from context4xi import get2context4xi         

from apu2context4xi import APU2Context4Xi                                                                           
from bpu2context4xi import BPU2Context4Xi
from cpu2context4xi import CPU2Context4Xi
from dpu2context4xi import DPU2Context4Xi
from epu2context4xi import EPU2Context4Xi
from fpu2context4xi import FPU2Context4Xi
from gpu2context4xi import GPU2Context4Xi
from hpu2context4xi import HPU2Context4Xi
from ipu2context4xi import IPU2Context4Xi
from jpu2context4xi import JPU2Context4Xi
from kpu2context4xi import KPU2Context4Xi
from lpu2context4xi import LPU2Context4Xi
from mpu2context4xi import MPU2Context4Xi
from npu2context4xi import NPU2Context4Xi
from opu2context4xi import OPU2Context4Xi
from ppu2context4xi import PPU2Context4Xi
from qpu2context4xi import QPU2Context4Xi
from rpu2context4xi import RPU2Context4Xi
from spu2context4xi import SPU2Context4Xi
from tpu2context4xi import TPU2Context4Xi
from upu2context4xi import UPU2Context4Xi
from vpu2context4xi import VPU2Context4Xi
from xpu2context4xi import XPU2Context4Xi
from wpu2context4xi import WPU2Context4Xi
from ypu2context4xi import YPU2Context4Xi
from zpu2context4xi import ZPU2Context4Xi

from apu2context4xi import create2context4apu 
from bpu2context4xi import create2context4bpu 
from cpu2context4xi import create2context4cpu 
from dpu2context4xi import create2context4dpu 
from epu2context4xi import create2context4epu 
from fpu2context4xi import create2context4fpu 
from gpu2context4xi import create2context4gpu 
from hpu2context4xi import create2context4hpu 
from ipu2context4xi import create2context4ipu 
from jpu2context4xi import create2context4jpu 
from kpu2context4xi import create2context4kpu 
from lpu2context4xi import create2context4lpu 
from mpu2context4xi import create2context4mpu 
from npu2context4xi import create2context4npu 
from opu2context4xi import create2context4opu 
from ppu2context4xi import create2context4ppu 
from qpu2context4xi import create2context4qpu 
from rpu2context4xi import create2context4rpu 
from spu2context4xi import create2context4spu 
from tpu2context4xi import create2context4tpu 
from upu2context4xi import create2context4upu 
from vpu2context4xi import create2context4vpu 
from xpu2context4xi import create2context4xpu 
from wpu2context4xi import create2context4wpu 
from ypu2context4xi import create2context4ypu 
from zpu2context4xi import create2context4zpu 


from apu2context4xi import get2context4apu
from bpu2context4xi import get2context4bpu
from cpu2context4xi import get2context4cpu
from dpu2context4xi import get2context4dpu
from epu2context4xi import get2context4epu
from fpu2context4xi import get2context4fpu
from gpu2context4xi import get2context4gpu
from hpu2context4xi import get2context4hpu
from ipu2context4xi import get2context4ipu
from jpu2context4xi import get2context4jpu
from kpu2context4xi import get2context4kpu
from lpu2context4xi import get2context4lpu
from mpu2context4xi import get2context4mpu
from npu2context4xi import get2context4npu
from opu2context4xi import get2context4opu
from ppu2context4xi import get2context4ppu
from qpu2context4xi import get2context4qpu
from rpu2context4xi import get2context4rpu
from spu2context4xi import get2context4spu
from tpu2context4xi import get2context4tpu
from upu2context4xi import get2context4upu
from vpu2context4xi import get2context4vpu
from xpu2context4xi import get2context4xpu
from wpu2context4xi import get2context4wpu
from ypu2context4xi import get2context4ypu
from zpu2context4xi import get2context4zpu

from apu2context4xi import release2context4apu
from bpu2context4xi import release2context4bpu
from cpu2context4xi import release2context4cpu
from dpu2context4xi import release2context4dpu
from epu2context4xi import release2context4epu
from fpu2context4xi import release2context4fpu
from gpu2context4xi import release2context4gpu
from hpu2context4xi import release2context4hpu
from ipu2context4xi import release2context4ipu
from jpu2context4xi import release2context4jpu
from kpu2context4xi import release2context4kpu
from lpu2context4xi import release2context4lpu
from mpu2context4xi import release2context4mpu
from npu2context4xi import release2context4npu
from opu2context4xi import release2context4opu
from ppu2context4xi import release2context4ppu
from qpu2context4xi import release2context4qpu
from rpu2context4xi import release2context4rpu
from spu2context4xi import release2context4spu
from tpu2context4xi import release2context4tpu
from upu2context4xi import release2context4upu
from vpu2context4xi import release2context4vpu
from xpu2context4xi import release2context4xpu
from wpu2context4xi import release2context4wpu
from ypu2context4xi import release2context4ypu
from zpu2context4xi import release2context4zpu

from apu2context4xi import retain2context4apu
from bpu2context4xi import retain2context4bpu
from cpu2context4xi import retain2context4cpu
from dpu2context4xi import retain2context4dpu
from epu2context4xi import retain2context4epu
from fpu2context4xi import retain2context4fpu
from gpu2context4xi import retain2context4gpu
from hpu2context4xi import retain2context4hpu
from ipu2context4xi import retain2context4ipu
from jpu2context4xi import retain2context4jpu
from kpu2context4xi import retain2context4kpu
from lpu2context4xi import retain2context4lpu
from mpu2context4xi import retain2context4mpu
from npu2context4xi import retain2context4npu
from opu2context4xi import retain2context4opu
from ppu2context4xi import retain2context4ppu
from qpu2context4xi import retain2context4qpu
from rpu2context4xi import retain2context4rpu
from spu2context4xi import retain2context4spu
from tpu2context4xi import retain2context4tpu
from upu2context4xi import retain2context4upu
from vpu2context4xi import retain2context4vpu
from xpu2context4xi import retain2context4xpu
from wpu2context4xi import retain2context4wpu
from ypu2context4xi import retain2context4ypu
from zpu2context4xi import retain2context4zpu

from apu2context4xi import set2context4apu
from bpu2context4xi import set2context4bpu
from cpu2context4xi import set2context4cpu
from dpu2context4xi import set2context4dpu
from epu2context4xi import set2context4epu
from fpu2context4xi import set2context4fpu
from gpu2context4xi import set2context4gpu
from hpu2context4xi import set2context4hpu
from ipu2context4xi import set2context4ipu
from jpu2context4xi import set2context4jpu
from kpu2context4xi import set2context4kpu
from lpu2context4xi import set2context4lpu
from mpu2context4xi import set2context4mpu
from npu2context4xi import set2context4npu
from opu2context4xi import set2context4opu
from ppu2context4xi import set2context4ppu
from qpu2context4xi import set2context4qpu
from rpu2context4xi import set2context4rpu
from spu2context4xi import set2context4spu
from tpu2context4xi import set2context4tpu
from upu2context4xi import set2context4upu
from vpu2context4xi import set2context4vpu
from xpu2context4xi import set2context4xpu
from wpu2context4xi import set2context4wpu
from ypu2context4xi import set2context4ypu
from zpu2context4xi import set2context4zpu


# -------------------------------------------------------------------------------------------------
# Device modules                           
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi                                                                                   
from device4xi import init2device4xi                                                                              
from device4xi import set2device4xi                                                                               
from device4xi import get2device4xi                                                                               

from apu2device4xi import APU4Xi                                                                                   
from bpu2device4xi import BPU4Xi
from cpu2device4xi import CPU4Xi
from dpu2device4xi import DPU4Xi
from epu2device4xi import EPU4Xi
from fpu2device4xi import FPU4Xi
from gpu2device4xi import GPU4Xi
from hpu2device4xi import HPU4Xi
from ipu2device4xi import IPU4Xi
from jpu2device4xi import JPU4Xi
from kpu2device4xi import KPU4Xi
from lpu2device4xi import LPU4Xi
from mpu2device4xi import MPU4Xi
from npu2device4xi import NPU4Xi
from opu2device4xi import OPU4Xi
from ppu2device4xi import PPU4Xi
from qpu2device4xi import QPU4Xi
from rpu2device4xi import RPU4Xi
from spu2device4xi import SPU4Xi
from tpu2device4xi import TPU4Xi
from upu2device4xi import UPU4Xi
from vpu2device4xi import VPU4Xi
from xpu2device4xi import XPU4Xi
from wpu2device4xi import WPU4Xi
from ypu2device4xi import YPU4Xi
from zpu2device4xi import ZPU4Xi

from apu2device4xi import init2apu4xi 
from bpu2device4xi import init2bpu4xi 
from cpu2device4xi import init2cpu4xi 
from dpu2device4xi import init2dpu4xi 
from epu2device4xi import init2epu4xi 
from fpu2device4xi import init2fpu4xi 
from gpu2device4xi import init2gpu4xi 
from hpu2device4xi import init2hpu4xi 
from ipu2device4xi import init2ipu4xi 
from jpu2device4xi import init2jpu4xi 
from kpu2device4xi import init2kpu4xi 
from lpu2device4xi import init2lpu4xi 
from mpu2device4xi import init2mpu4xi 
from npu2device4xi import init2npu4xi 
from opu2device4xi import init2opu4xi 
from ppu2device4xi import init2ppu4xi 
from qpu2device4xi import init2qpu4xi 
from rpu2device4xi import init2rpu4xi 
from spu2device4xi import init2spu4xi 
from tpu2device4xi import init2tpu4xi 
from upu2device4xi import init2upu4xi 
from vpu2device4xi import init2vpu4xi 
from xpu2device4xi import init2xpu4xi 
from wpu2device4xi import init2wpu4xi 
from ypu2device4xi import init2ypu4xi 
from zpu2device4xi import init2zpu4xi 

from apu2device4xi import set2apu4xi
from bpu2device4xi import set2bpu4xi
from cpu2device4xi import set2cpu4xi
from dpu2device4xi import set2dpu4xi
from epu2device4xi import set2epu4xi
from fpu2device4xi import set2fpu4xi
from gpu2device4xi import set2gpu4xi
from hpu2device4xi import set2hpu4xi
from ipu2device4xi import set2ipu4xi
from jpu2device4xi import set2jpu4xi
from kpu2device4xi import set2kpu4xi
from lpu2device4xi import set2lpu4xi
from mpu2device4xi import set2mpu4xi
from npu2device4xi import set2npu4xi
from opu2device4xi import set2opu4xi
from ppu2device4xi import set2ppu4xi
from qpu2device4xi import set2qpu4xi
from rpu2device4xi import set2rpu4xi
from spu2device4xi import set2spu4xi
from tpu2device4xi import set2tpu4xi
from upu2device4xi import set2upu4xi
from vpu2device4xi import set2vpu4xi
from xpu2device4xi import set2xpu4xi
from wpu2device4xi import set2wpu4xi
from ypu2device4xi import set2ypu4xi
from zpu2device4xi import set2zpu4xi

from apu2device4xi import get2apu4xi
from bpu2device4xi import get2bpu4xi
from cpu2device4xi import get2cpu4xi
from dpu2device4xi import get2dpu4xi
from epu2device4xi import get2epu4xi
from fpu2device4xi import get2fpu4xi
from gpu2device4xi import get2gpu4xi
from hpu2device4xi import get2hpu4xi
from ipu2device4xi import get2ipu4xi
from jpu2device4xi import get2jpu4xi
from kpu2device4xi import get2kpu4xi
from lpu2device4xi import get2lpu4xi
from mpu2device4xi import get2mpu4xi
from npu2device4xi import get2npu4xi
from opu2device4xi import get2opu4xi
from ppu2device4xi import get2ppu4xi
from qpu2device4xi import get2qpu4xi
from rpu2device4xi import get2rpu4xi
from spu2device4xi import get2spu4xi
from tpu2device4xi import get2tpu4xi
from upu2device4xi import get2upu4xi
from vpu2device4xi import get2vpu4xi
from xpu2device4xi import get2xpu4xi
from wpu2device4xi import get2wpu4xi
from ypu2device4xi import get2ypu4xi
from zpu2device4xi import get2zpu4xi


# -------------------------------------------------------------------------------------------------
# Platform                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global trace2scope 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                trace2scope.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            trace2scope.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global trace2scope
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Buffer4Xi': 'NACK4TRACE',
         'create2buffer4xi': 'NACK4TRACE',
         'create2subbuffer4xi': 'NACK4TRACE',
         'get2bufferinfo4xi': 'NACK4TRACE',
         'release2buffer4xi': 'NACK4TRACE',
         'retain2buffer4xi': 'NACK4TRACE',
         'set2buffer4xi': 'NACK4TRACE'
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        trace2scope.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>                  

           
   
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print2trace4xi" usage = "
# print XML trace for buffer4xi test
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(trace2scope):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-buffer4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Buffer in system.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Buffer sensed in system.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(trace2scope, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-buffer4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Buffer in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(trace2scope, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-buffer4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Buffer in system.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Buffer.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(trace2scope, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "buffer4xi5test" usage = "
# tests buffer4xi
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def buffer4xi5test():

    # ---------------------------------------------------------------------------------------------
    # START                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 1A/33) OF BUFFER4XI5TEST - STARTED ', time4xi()) 
    print('=' *33)   
    # 
    
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS                          
    # ---------------------------------------------------------------------------------------------
    
              
    # ---------------------------------------------------------------------------------------------
    # CREATE BUFFER WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) OF BUFFER4XI5TEST - TRYING TO CREATE BUFFER4XI ', time4xi())     
    print('=' *33)        
    # 11:49:44 05/22/11 Pacific Daylight Time
    
    try:
        cq2xi = create2buffer4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
        print('(Step 2B/33) OF BUFFER4XI5TEST - CREATED BUFFER4XI: ', cq2xi)                                  
        # {'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4dpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2buffer4dpu', 'METHOD': 'create2buffer4dpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4dpu at 0x0000000003B1F448>,
        #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000043419D0>, 'FLAGS': 0,
        #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x0000000003AE9CC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
        #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
        #  'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics
        #  cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query
        #  cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64,
        #  'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
        #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-
        # 42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE',
        #  'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018,
        #  'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A
        # -10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 'EPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0,
        #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4epu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4epu',
        #  'METHOD': 'create2buffer4epu'}, 'FUNCTION2CALLBACK': <function trace2buffer4epu at 0x0000000003B7E4C8>, 'POINTER2BUFFER': <mmap.mmap object at 0x0000000004341A28>,
        #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4epu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4epu', 'METHOD': 'create2context4epu'}, 'FUNCTION2CALLBACK': <function trace2context4epu at 0x0000000003B27D48>,
        #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1,
        #  'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4,
        #  'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0,
        #  'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics
        #  cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission
        #  cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3,
        #  'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
        #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A
        # -42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE',
        #  'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4033,
        #  'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128,
        #  'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_EPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A
        # -11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 'BPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4bpu-failed ;
        #  time: 23:27:47 09/01/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4bpu', 'METHOD': 'create2buffer4bpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4bpu at 0x0000000003A8D348>,
        #  'POINTER2BUFFER': <mmap.mmap object at 0x00000000043418C8>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4bpu-failed ;
        #  time: 23:27:47 09/01/11 Pacific Daylight Time}', 'CLASS': 'create2context4bpu', 'METHOD': 'create2context4bpu'}, 'FUNCTION2CALLBACK': <function trace2context4bpu at 0x0000000003A47BC8>,
        #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1,
        #  'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
        #  'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics
        #  cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A
        # -29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024,
        #  'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_BPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-',
        #  'SIZE': 278528}, 'CPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4cpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2buffer4cpu', 'METHOD': 'create2buffer4cpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4cpu at 0x0000000003ADD3C8>, 'POINTER2BUFFER': <mmap.mmap object at 0x0000000004341978>,
        #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4cpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4cpu', 'METHOD': 'create2context4cpu'}, 'FUNCTION2CALLBACK': <function trace2context4cpu at 0x0000000003A98C48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ',
        #  'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
        #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics 
        # cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-
        # 29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4017, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_CPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-',
        #  'SIZE': 278528}, 'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4vpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2buffer4vpu', 'METHOD': 'create2buffer4vpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4vpu at 0x00000000041C5D48>, 'POINTER2BUFFER': <mmap.mmap object at 0x0000000004341FA8>,
        #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x00000000041B2648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ',
        #  'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
        #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics
        #  cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A
        # -30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4005, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-',
        #  'SIZE': 278528}, 'RPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4rpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2buffer4rpu', 'METHOD': 'create2buffer4rpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4rpu at 0x0000000003FEBB48>, 'POINTER2BUFFER': <mmap.mmap object at 0x0000000004341EA0>,
        #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4rpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4rpu', 'METHOD': 'create2context4rpu'}, 'FUNCTION2CALLBACK': <function trace2context4rpu at 0x0000000003FDB448>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ',
        #  'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
        #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics 
        # cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A
        # -30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4022, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_RPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-',
        #  'SIZE': 278528}, 'WPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4wpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2buffer4wpu', 'METHOD': 'create2buffer4wpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4wpu at 0x000000000426AE48>, 'POINTER2BUFFER': <mmap.mmap object at 0x00000000048B5088>,
        #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4wpu-failed ; time: 23:27:47 09/01/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4wpu', 'METHOD': 'create2context4wpu'}, 'FUNCTION2CALLBACK': <function trace2context4wpu at 0x0000000004255748>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ',
        #  'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK',
        #  'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16,
        #  'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4,
        #  'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0',
        #  'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics
        #  cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing',
        #  'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD',
        #  'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A
        # -31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8,
        #  'ID': 4033, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024,
        #  'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK',
        #  'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK',
        #  'TYPE': 'CL_DEVICE_TYPE_WPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-',
        #  'SIZE': 278528}, 'SPU': {'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-11B-12B-13B-14B-15B-16B-17B-', 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4spu-failed ;
        #  time: 23:27:47 09/01/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4spu', 'METHOD': 'create2buffer4spu'}, 'FUNCTION2CALLBACK': <function trace2buffer4spu at 0x000000000408DBC8>,
        #  'POINTER2BUFFER': <mmap.mmap object at 0x0000000004341EF8>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4spu-failed ;
        #  time: 23:27:47 09/01/11 Pacific Daylight Time}', 'CLASS': 'create2context4spu', 'METHOD': 'create2context4spu'}, 'FUNCTION2CALLBACK': <function trace2context4spu at 0x000000000407B4C8>,
        #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1,
        #  'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024,
        #  'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1,
        #  'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANT
        # 
        #
    except:
        print('(Step 2Z/33) OF BUFFER4XI5TEST *** FAILED TO CREATE BUFFER4XI', time4xi()) 
    
    # ---------------------------------------------------------------------------------------------
    # GET BUFFER INFO WITH FUNCTION                   
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) OF BUFFER4XI5TEST - TRYING TO GET BUFFERINFO4XI', time4xi())  
    print('=' *33)    
    try:
        cqinfo2xi = get2bufferinfo4xi()                                                                       # AFTER SYSTEM CREATED  
        print('(Step 3B/33) OF BUFFER4XI5TEST - GOT BUFFERINFO4XI: ', cqinfo2xi)  
        # {'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4vpu-failed ; time: 05:57:34 05/23/11 Pacific Daylight Time}',
        #  'CLASS': 'create2buffer4vpu', 'METHOD': 'create2buffer4vpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4vpu at 0x00000000038D12C8>,
        #  'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003B78F98>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0,
        #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 05:57:34 05/23/11 Pacific Daylight Time}', 'CLASS': 'create2context4vpu',
        #  'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x000000000388CB48>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1},
        #  'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK',
        #  'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4,
        #  'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write',
        #  'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK',
        #  'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics
        #  cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing
        #  cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3,
        #  'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096,
        #  'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-
        # 40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024,
        #  'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210,
        #  'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4005, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD',
        #  'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK',
        #  'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1,
        #  'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_VPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'},
        #  'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
        #  'DPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2buffer4dpu-failed ; time: 05:57:34 05/23/11 Pacific Daylight Time}', 'CLASS': 'create2buffer4dpu', 'METHOD': 'create2buffer4dpu'}, 'FUNCTION2CALLBACK': <function trace2buffer4dpu at 0x00000000036F9D48>, 'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003A157B8>, 'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4dpu-failed ; time: 05:57:34 05/23/11 Pacific Daylight Time}', 'CLASS': 'create2context4dpu', 'METHOD': 'create2context4dpu'}, 'FUNCTION2CALLBACK': <function trace2context4dpu at 0x00000000036E8648>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK', 'EXECUTE2KERNELS4OPENCL': 'ACK', 'NATIVE2WIDTHLONG4VECTOR': 2, 'MAX2UNITS4COMPUTE': 4, 'SIZE2MEMORY4GLOBAL': 3221225472, 'NATIVE2WIDTHFLOAT4VECTOR': 4, 'MAX2SIZE4WORKGROUP': 1024, 'PREFERRED2WIDTHCHAR4VECTOR': 16, 'SIZE2CACHE': 65536, 'IEEE754-2008FUSED2MULTIPLY-ADD': 'NACK', 'TYPE4CACHE': 'Read/Write', 'PREFERRED2WIDTHINT4VECTOR': 4, 'SIZE2PREFERREDWORKGROUPMULTIPLE4KERNEL': 1, 'NATIVE2WIDTHINT4VECTOR': 4, 'SIZE2BUFFER4CONSTANT': 65536, 'EXECUTE2FUNCTION4NATIVE': 'ACK', 'PREFERRED2WIDTHDOUBLE4VECTOR': 0, 'MAX2NUMBER4CONSTANTARGS': 8, 'VERSION2DRIVER': '2.0', 'EXTENSIONS': 'cl_amd_fp64 cl_khr_global_int32_base_atomics cl_khr_global_int32_extended_atomics cl_khr_local_int32_base_atomics cl_khr_local_int32_extended_atomics cl_khr_int64_base_atomics cl_khr_int64_extended_atomics cl_khr_byte_addressable_store cl_khr_gl_sharing cl_ext_device_fission cl_amd_device_attribute_query cl_amd_media_ops cl_amd_popcnt cl_amd_printf cl_khr_d3d10_sharing', 'AVAILABLE2COMPILER': 'ACK', 'MAX2DIMENSIONS4WORKITEMS': 3, 'SUPPORT2CORRECTION4ERROR': 0, 'BITS2ADDRESS': 64, 'AVAILABLE': 'ACK', 'SIZE2MEMORY4LOCAL': 32768, 'VENDOR': 'AuthenticAMD', 'SUPPORT2IMAGE': 'NACK', 'MAX2SIZE4KERNELARGUMENT': 4096, 'ACK2RETURN': ' 1C-1D-1E-1F-1D-2A-3A-4A-5A-6A-7A-8A-9A-10A-11A-12A-13A-14A-15A-16A-17A-18A-19A-20A-21A-22A-23A-24A-25A-26A-27A-28A-29A-30A-31A-32A-33A-34A-35A-36A-37A-38A-39A-40A-41A-42A-43A-44A-45A-46A-47A-48A-49A-50A-51A-52A-53A-54A-55A-56A-57A-58A-59A-60A-', 'OUT-OF-ORDER2QUEUE': 'NACK', 'ALIGNMENT2ADDRESS4BASE': 1024, 'PROFILE': 'FULL_PROFILE', 'TYPE2MEMORY4LOCAL': 'Global', 'PREFERRED2WIDTHFLOAT4VECTOR': 4, 'PREFERRED2WIDTHLONG4VECTOR': 2, 'MAX2FREQUENCY4CLOCK': 3210, 'PREFERRED2WIDTHSHORT4VECTOR': 8, 'ID': 4018, 'MAX2WORKITEM2': 1024, 'NATIVE2WIDTHDOUBLE4VECTOR': 0, 'ROUND2ZERO': 'ACK', 'NAME': 'AMD64 Family 16 Model 4 Stepping 2, AuthenticAMD', 'MAX2WORKITEM1': 1024, 'MAX2WORKITEM0': 1024, 'SIZE2LINE4CACHE': 64, 'MAX2ALLOCATION4MEMORY': 1073741824, 'NATIVE2WIDTHCHAR4VECTOR': 16, 'QUIET2NANS': 'ACK', 'NATIVE2WIDTHSHORT4VECTOR': 8, 'ROUND2NEAREST4EVEN': 'ACK', 'VERSION': 'OpenCL 1.1 ATI-Stream-v2.3 (451)', 'NACK2RETURN': ' ', 'MEMORY2UNIFIED4HOSTANDDEVICE': 1, 'ENDIANESS2DEVICE': 'Little', 'MINIMUM2ALIGNMENT4DATATYPE': 128, 'ROUND2+VE3INFINITY': 'ACK', 'TYPE': 'CL_DEVICE_TYPE_DPU', 'DENORMS2SINGLEPRECISION4FLOATINGPOINTCAPABILITY': 'ACK'}, 'NACK2RETURN': ' ', 'ACK2RETURN': ' 1D-1E-2C-2B-3B-4B-6A-7A-8A-8E-9A-10A-11B-12B-13B-14B-15B-16B-17B-18B-19B-', 'SIZE': 278528}, 
        
        #  'RPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0,...
        
        #  'SPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ....
        
        #  'APU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        #  'PPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        #   GPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
        #  'CPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
        
    except:
        print('(Step 3Z/33) OF BUFFER4XI5TEST *** FAILED TO GET BUFFER4XI', time4xi())
            
    
    # ---------------------------------------------------------------------------------------------
    # SET BUFFERINFO WITH FUNCTION - ALL ATTRIBUTES                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4A/33) OF BUFFER4XI5TEST - TRYING TO SET BUFFERINFO WITH FUNCTION ', time4xi())    
    print('=' *33)
    
    # ---------------------------------------------------------------------------------------------
    # (1) GET PLATFORM IDs TO SET CONTEXT
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4B/33) OF CONTEXT4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
    print('=' *33)    
    platform2xi = {}
    try:
        platform2xi = get2platformids4xi()
        print('(Step 4B/33) of CONTEXT4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
        # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}  
        
    except:
        print('(Step 4Z/33) of CONTEXT4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     

    # ---------------------------------------------------------------------------------------------
    # (2) INITIALIZE DEVICES - ALL                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/33) OF BUFFER4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
    print('=' *33)        
    try:
        device2xi = init2device4xi()                                                                                # NO PARAMETERS - THE SYSTEM SHOULD INITIALIZE ALL   
        print('(Step 2B/33) OF BUFFER4XI5TEST - INITIALIZED DEVICE4XI TO: ', device2xi)        
        # {'VPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...
        
    except:
        print('(Step 2Z/33) OF BUFFER4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi()) 
            
        
    # ---------------------------------------------------------------------------------------------
    # (3) CREATE CONTEXT - SYSTEM                         
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 3A/33) OF CONTEXT4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
    print('=' *33)        
    try:
        context2xi = create2context4xi()                                                                            # NO PARAMETERS - THE SYSTEM CREATES   
        print('(Step 3B/33) OF CONTEXT4XI5TEST - CREATED CONTEXT4XI: ', context2xi)                                  
        # {'VPU': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE':  ...
        
    except:
        print('(Step 3Z/33) OF CONTEXT4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
     

          
    # ---------------------------------------------------------------------------------------------
    # (4) INITIALIZE TASK DICTIONARY                          
    # ---------------------------------------------------------------------------------------------            
    task4create2buffer = {}
    task4create2buffer ['APU'] = {}
    task4create2buffer ['BPU'] = {}
    task4create2buffer ['CPU'] = {}
    task4create2buffer ['DPU'] = {}
    task4create2buffer ['EPU'] = {}
    task4create2buffer ['FPU'] = {}
    task4create2buffer ['GPU'] = {}
    task4create2buffer ['HPU'] = {}
    task4create2buffer ['IPU'] = {}
    task4create2buffer ['JPU'] = {}
    task4create2buffer ['KPU'] = {}
    task4create2buffer ['LPU'] = {}
    task4create2buffer ['MPU'] = {}
    task4create2buffer ['NPU'] = {}
    task4create2buffer ['OPU'] = {}
    task4create2buffer ['PPU'] = {}
    task4create2buffer ['QPU'] = {}
    task4create2buffer ['RPU'] = {}
    task4create2buffer ['SPU'] = {}
    task4create2buffer ['TPU'] = {}
    task4create2buffer ['UPU'] = {}
    task4create2buffer ['VPU'] = {}
    task4create2buffer ['XPU'] = {}
    task4create2buffer ['WPU'] = {}
    task4create2buffer ['YPU'] = {}
    task4create2buffer ['ZPU'] = {}
    
    # ---------------------------------------------------------------------------------------------
    # (5) DEFINE CONTEXT                           
    # ---------------------------------------------------------------------------------------------         
    task4create2buffer ['APU'] ['CONTEXT'] = context2xi ['APU'] 
    task4create2buffer ['BPU'] ['CONTEXT'] = context2xi ['BPU'] 
    task4create2buffer ['CPU'] ['CONTEXT'] = context2xi ['CPU'] 
    task4create2buffer ['DPU'] ['CONTEXT'] = context2xi ['DPU'] 
    task4create2buffer ['EPU'] ['CONTEXT'] = context2xi ['EPU'] 
    task4create2buffer ['FPU'] ['CONTEXT'] = context2xi ['FPU'] 
    task4create2buffer ['GPU'] ['CONTEXT'] = context2xi ['GPU'] 
    task4create2buffer ['HPU'] ['CONTEXT'] = context2xi ['HPU'] 
    task4create2buffer ['IPU'] ['CONTEXT'] = context2xi ['IPU'] 
    task4create2buffer ['JPU'] ['CONTEXT'] = context2xi ['JPU'] 
    task4create2buffer ['KPU'] ['CONTEXT'] = context2xi ['KPU'] 
    task4create2buffer ['LPU'] ['CONTEXT'] = context2xi ['LPU'] 
    task4create2buffer ['MPU'] ['CONTEXT'] = context2xi ['MPU'] 
    task4create2buffer ['NPU'] ['CONTEXT'] = context2xi ['NPU'] 
    task4create2buffer ['OPU'] ['CONTEXT'] = context2xi ['OPU'] 
    task4create2buffer ['PPU'] ['CONTEXT'] = context2xi ['PPU'] 
    task4create2buffer ['QPU'] ['CONTEXT'] = context2xi ['QPU'] 
    task4create2buffer ['RPU'] ['CONTEXT'] = context2xi ['RPU'] 
    task4create2buffer ['SPU'] ['CONTEXT'] = context2xi ['SPU'] 
    task4create2buffer ['TPU'] ['CONTEXT'] = context2xi ['TPU'] 
    task4create2buffer ['UPU'] ['CONTEXT'] = context2xi ['UPU'] 
    task4create2buffer ['VPU'] ['CONTEXT'] = context2xi ['VPU'] 
    task4create2buffer ['XPU'] ['CONTEXT'] = context2xi ['XPU'] 
    task4create2buffer ['WPU'] ['CONTEXT'] = context2xi ['WPU'] 
    task4create2buffer ['YPU'] ['CONTEXT'] = context2xi ['YPU'] 
    task4create2buffer ['ZPU'] ['CONTEXT'] = context2xi ['ZPU']                            
    
    
    # ---------------------------------------------------------------------------------------------
    # (6) DEFINE FLAGS                           
    # ---------------------------------------------------------------------------------------------         
    task4create2buffer ['APU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['BPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['CPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['DPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['EPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['FPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['GPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['HPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['IPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['JPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['KPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['LPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['MPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['NPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['OPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['PPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['QPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['RPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['SPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['TPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['UPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['VPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['XPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['WPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['YPU'] ['FLAGS'] = 0b00000000000000000000000000000000
    task4create2buffer ['ZPU'] ['FLAGS'] = 0b00000000000000000000000000000000                       
        
    # ---------------------------------------------------------------------------------------------
    # (7) DEFINE SIZE OF MEMORY OBJECT                           
    # ---------------------------------------------------------------------------------------------         
    task4create2buffer ['APU'] ['SIZE'] = 33792 
    task4create2buffer ['BPU'] ['SIZE'] = 33792 
    task4create2buffer ['CPU'] ['SIZE'] = 33792 
    task4create2buffer ['DPU'] ['SIZE'] = 33792 
    task4create2buffer ['EPU'] ['SIZE'] = 33792 
    task4create2buffer ['FPU'] ['SIZE'] = 33792 
    task4create2buffer ['GPU'] ['SIZE'] = 33792 
    task4create2buffer ['HPU'] ['SIZE'] = 33792 
    task4create2buffer ['IPU'] ['SIZE'] = 33792 
    task4create2buffer ['JPU'] ['SIZE'] = 33792 
    task4create2buffer ['KPU'] ['SIZE'] = 33792 
    task4create2buffer ['LPU'] ['SIZE'] = 33792 
    task4create2buffer ['MPU'] ['SIZE'] = 33792 
    task4create2buffer ['NPU'] ['SIZE'] = 33792 
    task4create2buffer ['OPU'] ['SIZE'] = 33792 
    task4create2buffer ['PPU'] ['SIZE'] = 33792 
    task4create2buffer ['QPU'] ['SIZE'] = 33792 
    task4create2buffer ['RPU'] ['SIZE'] = 33792 
    task4create2buffer ['SPU'] ['SIZE'] = 33792 
    task4create2buffer ['TPU'] ['SIZE'] = 33792 
    task4create2buffer ['UPU'] ['SIZE'] = 33792 
    task4create2buffer ['VPU'] ['SIZE'] = 33792 
    task4create2buffer ['XPU'] ['SIZE'] = 33792 
    task4create2buffer ['WPU'] ['SIZE'] = 33792 
    task4create2buffer ['YPU'] ['SIZE'] = 33792 
    task4create2buffer ['ZPU'] ['SIZE'] = 33792 
    
    # ---------------------------------------------------------------------------------------------
    # (8) ALLOCATE AND SET POINTERS TO BUFFERS                           
    # ---------------------------------------------------------------------------------------------         

    # -----------------------------------------------------------------------------------------
    # (8A) ARENA TO APU
    # ----------------------------------------------------------------------------------------- 
    length2apu = task4create2buffer ['APU'] ['SIZE']
    arena2apu = None
    print("STEP 8A1/33 TRYING TO ALLOCATE ARENA TO APU OF LENGTH: ", length2apu)
    # 
    try:
        arena2apu = Arena4Xi(length2apu)
        print("STEP 8A2/33 CREATED ARENA2APU: ", arena2apu)
        # 
        print("STEP 8A3/33 SIZE OF ARENA2APU: ", arena2apu.size)
        #                
    except:
        print("STEP 8AZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['APU'] ['POINTER2BUFFER'] = arena2apu.buffer

    # -----------------------------------------------------------------------------------------
    # (8B) ARENA TO BPU
    # ----------------------------------------------------------------------------------------- 
    length2bpu = task4create2buffer ['BPU'] ['SIZE']
    arena2bpu = None
    print("STEP 8B1/33 TRYING TO ALLOCATE ARENA TO BPU OF LENGTH: ", length2bpu)
    # 
    try:
        arena2bpu = Arena4Xi(length2bpu)
        print("STEP 8B2/33 CREATED ARENA2BPU: ", arena2bpu)
        # 
        print("STEP 8B3/33 SIZE OF ARENA2BPU: ", arena2bpu.size)
        #                
    except:
        print("STEP 8BZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['BPU'] ['POINTER2BUFFER'] = arena2bpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8C) ARENA TO CPU
    # ----------------------------------------------------------------------------------------- 
    length2cpu = task4create2buffer ['CPU'] ['SIZE']
    arena2cpu = None
    print("STEP 8C1/33 TRYING TO ALLOCATE ARENA TO CPU OF LENGTH: ", length2cpu)
    # 
    try:
        arena2cpu = Arena4Xi(length2cpu)
        print("STEP 8C2/33 CREATED ARENA2CPU: ", arena2cpu)
        # 
        print("STEP 8C3/33 SIZE OF ARENA2CPU: ", arena2cpu.size)
        #                
    except:
        print("STEP 8CZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['CPU'] ['POINTER2BUFFER'] = arena2cpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8D) ARENA TO DPU
    # ----------------------------------------------------------------------------------------- 
    length2dpu = task4create2buffer ['DPU'] ['SIZE']
    arena2dpu = None
    print("STEP 8D1/33 TRYING TO ALLOCATE ARENA TO DPU OF LENGTH: ", length2dpu)
    # 
    try:
        arena2dpu = Arena4Xi(length2dpu)
        print("STEP 8D2/33 CREATED ARENA2DPU: ", arena2dpu)
        # 
        print("STEP 8D3/33 SIZE OF ARENA2DPU: ", arena2dpu.size)
        #                
    except:
        print("STEP 8DZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['DPU'] ['POINTER2BUFFER'] = arena2dpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8E) ARENA TO EPU
    # ----------------------------------------------------------------------------------------- 
    length2epu = task4create2buffer ['EPU'] ['SIZE']
    arena2epu = None
    print("STEP 8E1/33 TRYING TO ALLOCATE ARENA TO EPU OF LENGTH: ", length2epu)
    # 
    try:
        arena2epu = Arena4Xi(length2epu)
        print("STEP 8E2/33 CREATED ARENA2EPU: ", arena2epu)
        # 
        print("STEP 8E3/33 SIZE OF ARENA2EPU: ", arena2epu.size)
        #                
    except:
        print("STEP 8EZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['EPU'] ['POINTER2BUFFER'] = arena2epu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8F) ARENA TO FPU
    # ----------------------------------------------------------------------------------------- 
    length2fpu = task4create2buffer ['FPU'] ['SIZE']
    arena2fpu = None
    print("STEP 8F1/33 TRYING TO ALLOCATE ARENA TO FPU OF LENGTH: ", length2fpu)
    # 
    try:
        arena2fpu = Arena4Xi(length2fpu)
        print("STEP 8F2/33 CREATED ARENA2FPU: ", arena2fpu)
        # 
        print("STEP 8F3/33 SIZE OF ARENA2FPU: ", arena2fpu.size)
        #                
    except:
        print("STEP 8FZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['FPU'] ['POINTER2BUFFER'] = arena2fpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8G) ARENA TO GPU
    # ----------------------------------------------------------------------------------------- 
    length2gpu = task4create2buffer ['GPU'] ['SIZE']
    arena2gpu = None
    print("STEP 8G1/33 TRYING TO ALLOCATE ARENA TO GPU OF LENGTH: ", length2gpu)
    # 
    try:
        arena2gpu = Arena4Xi(length2gpu)
        print("STEP 8G2/33 CREATED ARENA2GPU: ", arena2gpu)
        # 
        print("STEP 8G3/33 SIZE OF ARENA2GPU: ", arena2gpu.size)
        #                
    except:
        print("STEP 8GZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['GPU'] ['POINTER2BUFFER'] = arena2gpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8H) ARENA TO HPU
    # ----------------------------------------------------------------------------------------- 
    length2hpu = task4create2buffer ['HPU'] ['SIZE']
    arena2hpu = None
    print("STEP 8H1/33 TRYING TO ALLOCATE ARENA TO HPU OF LENGTH: ", length2hpu)
    # 
    try:
        arena2hpu = Arena4Xi(length2hpu)
        print("STEP 8H2/33 CREATED ARENA2HPU: ", arena2hpu)
        # 
        print("STEP 8H3/33 SIZE OF ARENA2HPU: ", arena2hpu.size)
        #                
    except:
        print("STEP 8HZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['HPU'] ['POINTER2BUFFER'] = arena2hpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8I) ARENA TO IPU
    # ----------------------------------------------------------------------------------------- 
    length2ipu = task4create2buffer ['IPU'] ['SIZE']
    arena2ipu = None
    print("STEP 8I1/33 TRYING TO ALLOCATE ARENA TO IPU OF LENGTH: ", length2ipu)
    # 
    try:
        arena2ipu = Arena4Xi(length2ipu)
        print("STEP 8I2/33 CREATED ARENA2IPU: ", arena2ipu)
        # 
        print("STEP 8I3/33 SIZE OF ARENA2IPU: ", arena2ipu.size)
        #                
    except:
        print("STEP 8IZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['IPU'] ['POINTER2BUFFER'] = arena2ipu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8J) ARENA TO JPU
    # ----------------------------------------------------------------------------------------- 
    length2jpu = task4create2buffer ['JPU'] ['SIZE']
    arena2jpu = None
    print("STEP 8J1/33 TRYING TO ALLOCATE ARENA TO JPU OF LENGTH: ", length2jpu)
    # 
    try:
        arena2jpu = Arena4Xi(length2jpu)
        print("STEP 8J2/33 CREATED ARENA2JPU: ", arena2jpu)
        # 
        print("STEP 8J3/33 SIZE OF ARENA2JPU: ", arena2jpu.size)
        #                
    except:
        print("STEP 8JZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['JPU'] ['POINTER2BUFFER'] = arena2jpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8K) ARENA TO KPU
    # ----------------------------------------------------------------------------------------- 
    length2kpu = task4create2buffer ['KPU'] ['SIZE']
    arena2kpu = None
    print("STEP 8K1/33 TRYING TO ALLOCATE ARENA TO KPU OF LENGTH: ", length2kpu)
    # 
    try:
        arena2kpu = Arena4Xi(length2kpu)
        print("STEP 8K2/33 CREATED ARENA2KPU: ", arena2kpu)
        # 
        print("STEP 8K3/33 SIZE OF ARENA2KPU: ", arena2kpu.size)
        #                
    except:
        print("STEP 8KZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['KPU'] ['POINTER2BUFFER'] = arena2kpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8L) ARENA TO LPU
    # ----------------------------------------------------------------------------------------- 
    length2lpu = task4create2buffer ['LPU'] ['SIZE']
    arena2lpu = None
    print("STEP 8L1/33 TRYING TO ALLOCATE ARENA TO LPU OF LENGTH: ", length2lpu)
    # 
    try:
        arena2lpu = Arena4Xi(length2lpu)
        print("STEP 8L2/33 CREATED ARENA2LPU: ", arena2lpu)
        # 
        print("STEP 8L3/33 SIZE OF ARENA2LPU: ", arena2lpu.size)
        #                
    except:
        print("STEP 8LZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['LPU'] ['POINTER2BUFFER'] = arena2lpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8M) ARENA TO MPU
    # ----------------------------------------------------------------------------------------- 
    length2mpu = task4create2buffer ['MPU'] ['SIZE']
    arena2mpu = None
    print("STEP 8M1/33 TRYING TO ALLOCATE ARENA TO MPU OF LENGTH: ", length2mpu)
    # 
    try:
        arena2mpu = Arena4Xi(length2mpu)
        print("STEP 8M2/33 CREATED ARENA2MPU: ", arena2mpu)
        # 
        print("STEP 8M3/33 SIZE OF ARENA2MPU: ", arena2mpu.size)
        #                
    except:
        print("STEP 8MZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['MPU'] ['POINTER2BUFFER'] = arena2mpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8N) ARENA TO NPU
    # ----------------------------------------------------------------------------------------- 
    length2npu = task4create2buffer ['NPU'] ['SIZE']
    arena2npu = None
    print("STEP 8N1/33 TRYING TO ALLOCATE ARENA TO NPU OF LENGTH: ", length2npu)
    # 
    try:
        arena2npu = Arena4Xi(length2npu)
        print("STEP 8N2/33 CREATED ARENA2NPU: ", arena2npu)
        # 
        print("STEP 8N3/33 SIZE OF ARENA2NPU: ", arena2npu.size)
        #                
    except:
        print("STEP 8NZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['NPU'] ['POINTER2BUFFER'] = arena2npu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8O) ARENA TO OPU
    # ----------------------------------------------------------------------------------------- 
    length2opu = task4create2buffer ['OPU'] ['SIZE']
    arena2opu = None
    print("STEP 8O1/33 TRYING TO ALLOCATE ARENA TO OPU OF LENGTH: ", length2opu)
    # 
    try:
        arena2opu = Arena4Xi(length2opu)
        print("STEP 8O2/33 CREATED ARENA2OPU: ", arena2opu)
        # 
        print("STEP 8O3/33 SIZE OF ARENA2OPU: ", arena2opu.size)
        #                
    except:
        print("STEP 8OZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['OPU'] ['POINTER2BUFFER'] = arena2opu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8P) ARENA TO PPU
    # ----------------------------------------------------------------------------------------- 
    length2ppu = task4create2buffer ['PPU'] ['SIZE']
    arena2ppu = None
    print("STEP 8P1/33 TRYING TO ALLOCATE ARENA TO PPU OF LENGTH: ", length2ppu)
    # 
    try:
        arena2ppu = Arena4Xi(length2ppu)
        print("STEP 8P2/33 CREATED ARENA2PPU: ", arena2ppu)
        # 
        print("STEP 8P3/33 SIZE OF ARENA2PPU: ", arena2ppu.size)
        #                
    except:
        print("STEP 8PZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['PPU'] ['POINTER2BUFFER'] = arena2ppu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8Q) ARENA TO QPU
    # ----------------------------------------------------------------------------------------- 
    length2qpu = task4create2buffer ['QPU'] ['SIZE']
    arena2qpu = None
    print("STEP 8Q1/33 TRYING TO ALLOCATE ARENA TO QPU OF LENGTH: ", length2qpu)
    # 
    try:
        arena2qpu = Arena4Xi(length2qpu)
        print("STEP 8Q2/33 CREATED ARENA2QPU: ", arena2qpu)
        # 
        print("STEP 8Q3/33 SIZE OF ARENA2QPU: ", arena2qpu.size)
        #                
    except:
        print("STEP 8QZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['QPU'] ['POINTER2BUFFER'] = arena2qpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8R) ARENA TO RPU
    # ----------------------------------------------------------------------------------------- 
    length2rpu = task4create2buffer ['RPU'] ['SIZE']
    arena2rpu = None
    print("STEP 8R1/33 TRYING TO ALLOCATE ARENA TO RPU OF LENGTH: ", length2rpu)
    # 
    try:
        arena2rpu = Arena4Xi(length2rpu)
        print("STEP 8R2/33 CREATED ARENA2RPU: ", arena2rpu)
        # 
        print("STEP 8R3/33 SIZE OF ARENA2RPU: ", arena2rpu.size)
        #                
    except:
        print("STEP 8RZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['RPU'] ['POINTER2BUFFER'] = arena2rpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8S) ARENA TO SPU
    # ----------------------------------------------------------------------------------------- 
    length2spu = task4create2buffer ['SPU'] ['SIZE']
    arena2spu = None
    print("STEP 8S1/33 TRYING TO ALLOCATE ARENA TO SPU OF LENGTH: ", length2spu)
    # 
    try:
        arena2spu = Arena4Xi(length2spu)
        print("STEP 8S2/33 CREATED ARENA2SPU: ", arena2spu)
        # 
        print("STEP 8S3/33 SIZE OF ARENA2SPU: ", arena2spu.size)
        #                
    except:
        print("STEP 8SZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['SPU'] ['POINTER2BUFFER'] = arena2spu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8T) ARENA TO TPU
    # ----------------------------------------------------------------------------------------- 
    length2tpu = task4create2buffer ['TPU'] ['SIZE']
    arena2tpu = None
    print("STEP 8T1/33 TRYING TO ALLOCATE ARENA TO TPU OF LENGTH: ", length2tpu)
    # 
    try:
        arena2tpu = Arena4Xi(length2tpu)
        print("STEP 8T2/33 CREATED ARENA2TPU: ", arena2tpu)
        # 
        print("STEP 8T3/33 SIZE OF ARENA2TPU: ", arena2tpu.size)
        #                
    except:
        print("STEP 8TZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['TPU'] ['POINTER2BUFFER'] = arena2tpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8U) ARENA TO UPU
    # ----------------------------------------------------------------------------------------- 
    length2upu = task4create2buffer ['UPU'] ['SIZE']
    arena2upu = None
    print("STEP 8U1/33 TRYING TO ALLOCATE ARENA TO UPU OF LENGTH: ", length2upu)
    # 
    try:
        arena2upu = Arena4Xi(length2upu)
        print("STEP 8U2/33 CREATED ARENA2UPU: ", arena2upu)
        # 
        print("STEP 8U3/33 SIZE OF ARENA2UPU: ", arena2upu.size)
        #                
    except:
        print("STEP 8UZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['UPU'] ['POINTER2BUFFER'] = arena2upu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8V) ARENA TO VPU
    # ----------------------------------------------------------------------------------------- 
    length2vpu = task4create2buffer ['VPU'] ['SIZE']
    arena2vpu = None
    print("STEP 8V1/33 TRYING TO ALLOCATE ARENA TO VPU OF LENGTH: ", length2vpu)
    # 
    try:
        arena2vpu = Arena4Xi(length2vpu)
        print("STEP 8V2/33 CREATED ARENA2VPU: ", arena2vpu)
        # 
        print("STEP 8V3/33 SIZE OF ARENA2VPU: ", arena2vpu.size)
        #                
    except:
        print("STEP 8VZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['VPU'] ['POINTER2BUFFER'] = arena2vpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8W) ARENA TO WPU
    # ----------------------------------------------------------------------------------------- 
    length2wpu = task4create2buffer ['WPU'] ['SIZE']
    arena2wpu = None
    print("STEP 8W1/33 TRYING TO ALLOCATE ARENA TO WPU OF LENGTH: ", length2wpu)
    # 
    try:
        arena2wpu = Arena4Xi(length2wpu)
        print("STEP 8W2/33 CREATED ARENA2WPU: ", arena2wpu)
        # 
        print("STEP 8W3/33 SIZE OF ARENA2WPU: ", arena2wpu.size)
        #                
    except:
        print("STEP 8WZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['WPU'] ['POINTER2BUFFER'] = arena2wpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8X) ARENA TO XPU
    # ----------------------------------------------------------------------------------------- 
    length2xpu = task4create2buffer ['XPU'] ['SIZE']
    arena2xpu = None
    print("STEP 8X1/33 TRYING TO ALLOCATE ARENA TO XPU OF LENGTH: ", length2xpu)
    # 
    try:
        arena2xpu = Arena4Xi(length2xpu)
        print("STEP 8X2/33 CREATED ARENA2XPU: ", arena2xpu)
        # 
        print("STEP 8X3/33 SIZE OF ARENA2XPU: ", arena2xpu.size)
        #                
    except:
        print("STEP 8XZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['XPU'] ['POINTER2BUFFER'] = arena2xpu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8Y) ARENA TO YPU
    # ----------------------------------------------------------------------------------------- 
    length2ypu = task4create2buffer ['YPU'] ['SIZE']
    arena2ypu = None
    print("STEP 8Y1/33 TRYING TO ALLOCATE ARENA TO YPU OF LENGTH: ", length2ypu)
    # 
    try:
        arena2ypu = Arena4Xi(length2ypu)
        print("STEP 8Y2/33 CREATED ARENA2YPU: ", arena2ypu)
        # 
        print("STEP 8Y3/33 SIZE OF ARENA2YPU: ", arena2ypu.size)
        #                
    except:
        print("STEP 8YZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['YPU'] ['POINTER2BUFFER'] = arena2ypu.buffer
    
    # -----------------------------------------------------------------------------------------
    # (8Z) ARENA TO ZPU
    # ----------------------------------------------------------------------------------------- 
    length2zpu = task4create2buffer ['ZPU'] ['SIZE']
    arena2zpu = None
    print("STEP 8Z1/33 TRYING TO ALLOCATE ARENA TO ZPU OF LENGTH: ", length2zpu)
    # 
    try:
        arena2zpu = Arena4Xi(length2zpu)
        print("STEP 8Z2/33 CREATED ARENA2ZPU: ", arena2zpu)
        # 
        print("STEP 8Z3/33 SIZE OF ARENA2ZPU: ", arena2zpu.size)
        #                
    except:
        print("STEP 8ZZ/33 EXCEPTION: *** FAILED TO CREATE ARENA2xi")
    task4create2buffer ['ZPU'] ['POINTER2BUFFER'] = arena2zpu.buffer


   
 
    # -----------------------------------------------------------------------------------------
    # (9) BUFFER TO ALL DEVICES
    # -----------------------------------------------------------------------------------------      
    response4create2buffer = {} 
    print('(Step 9A/33) OF BUFFER4XI5TEST - TRYING TO GET RESPONSE FOR CREATE2BUFFER4XI ', time4xi())   
    try:                               
        response4create2buffer = create2buffer4xi(task4create2buffer)                                                     # ALL ATTRIBUTES SET                                                        
        print('(Step 9B/33) OF BUFFER4XI5TEST - RESPONSE4SET2BUFFER : ', response4create2buffer)                           
        # {'VPU': {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x000000000400A390>, 'ACK2RETURN': ' 13B-15B-16B-17B-' ...
        
    except:
        print('(Step 9Z/33) OF BUFFER4XI5TEST *** FAILED TO GET RESPONSE FOR CREATE2BUFFER4XI ', time4xi())  
        
    
    # ---------------------------------------------------------------------------------------------
    # (10) RELEASE REFERENCE COUNT FOR EACH PROCESSING UNIT BY DECREMENTING COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    task4release2buffer = {}
    task4release2buffer ['APU'] = {} 
    task4release2buffer ['BPU'] = {} 
    task4release2buffer ['CPU'] = {} 
    task4release2buffer ['DPU'] = {} 
    task4release2buffer ['EPU'] = {} 
    task4release2buffer ['FPU'] = {} 
    task4release2buffer ['GPU'] = {} 
    task4release2buffer ['HPU'] = {} 
    task4release2buffer ['IPU'] = {} 
    task4release2buffer ['JPU'] = {} 
    task4release2buffer ['KPU'] = {} 
    task4release2buffer ['LPU'] = {} 
    task4release2buffer ['MPU'] = {} 
    task4release2buffer ['NPU'] = {} 
    task4release2buffer ['OPU'] = {} 
    task4release2buffer ['PPU'] = {} 
    task4release2buffer ['QPU'] = {} 
    task4release2buffer ['RPU'] = {} 
    task4release2buffer ['SPU'] = {} 
    task4release2buffer ['TPU'] = {} 
    task4release2buffer ['UPU'] = {} 
    task4release2buffer ['VPU'] = {} 
    task4release2buffer ['XPU'] = {} 
    task4release2buffer ['WPU'] = {} 
    task4release2buffer ['YPU'] = {} 
    task4release2buffer ['ZPU'] = {} 
     
    task4release2buffer ['APU'] ['COUNT2REFERENCE'] = 1                                                       
    task4release2buffer ['BPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['CPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['DPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['EPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['FPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['GPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['HPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['IPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['JPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['KPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['LPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['MPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['NPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['OPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['PPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['QPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['RPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['SPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['TPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['UPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['VPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['XPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['WPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['YPU'] ['COUNT2REFERENCE'] = 1    
    task4release2buffer ['ZPU'] ['COUNT2REFERENCE'] = 1      
    
    response4release2buffer = {}
    
    print('(Step 10A/33) OF BUFFER4XI5TEST - TRYING TO RELEASE BUFFER OF EACH DEVICE ', time4xi())   
    try:                               
        response4release2buffer = release2buffer4xi(task4release2buffer)                                         # COUNT2REFERENCE                                                      
        print('(Step 10B/33) OF BUFFER4XI5TEST - RESPONSE4RELEASE2BUFFER : ', response4release2buffer)                           
        # {'VPU': {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x000000000400A390>, 'ACK2RETURN': ' ', 'COUNT2REFERENCE': 0, 'NACK2RETURN': ' 8Z1-' ...
        
    except:
        print('(Step 10Z/33) OF BUFFER4XI5TEST *** FAILED TO RELEASE BUFFER OF EACH DEVICE ', time4xi())  
                
    
    # ---------------------------------------------------------------------------------------------
    # (11) REFERENCE COUNT FOR EACH PROCESSING UNIT RETAINED BY INCREMENTING COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    task4retain2buffer = {}
    task4retain2buffer ['APU'] = {} 
    task4retain2buffer ['BPU'] = {} 
    task4retain2buffer ['CPU'] = {} 
    task4retain2buffer ['DPU'] = {} 
    task4retain2buffer ['EPU'] = {} 
    task4retain2buffer ['FPU'] = {} 
    task4retain2buffer ['GPU'] = {} 
    task4retain2buffer ['HPU'] = {} 
    task4retain2buffer ['IPU'] = {} 
    task4retain2buffer ['JPU'] = {} 
    task4retain2buffer ['KPU'] = {} 
    task4retain2buffer ['LPU'] = {} 
    task4retain2buffer ['MPU'] = {} 
    task4retain2buffer ['NPU'] = {} 
    task4retain2buffer ['OPU'] = {} 
    task4retain2buffer ['PPU'] = {} 
    task4retain2buffer ['QPU'] = {} 
    task4retain2buffer ['RPU'] = {} 
    task4retain2buffer ['SPU'] = {} 
    task4retain2buffer ['TPU'] = {} 
    task4retain2buffer ['UPU'] = {} 
    task4retain2buffer ['VPU'] = {} 
    task4retain2buffer ['XPU'] = {} 
    task4retain2buffer ['WPU'] = {} 
    task4retain2buffer ['YPU'] = {} 
    task4retain2buffer ['ZPU'] = {} 
     
    task4retain2buffer ['APU'] ['COUNT2REFERENCE'] = 1                                                            
    task4retain2buffer ['BPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['CPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['DPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['EPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['FPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['GPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['HPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['IPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['JPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['KPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['LPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['MPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['NPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['OPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['PPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['QPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['RPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['SPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['TPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['UPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['VPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['XPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['WPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['YPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['ZPU'] ['COUNT2REFERENCE'] = 1        
    
    response4retain2buffer = {}
    
    print('(Step 11A/33) OF BUFFER4XI5TEST - TRYING TO RETAIN BUFFER OF EACH DEVICE ', time4xi())  
    try:                               
        response4retain2buffer = retain2buffer4xi(task4retain2buffer)                                 # COUNT2REFERENCE                                                      
        print('(Step 11B/33) OF BUFFER4XI5TEST - RESPONSE4RELEASE2BUFFER : ', response4retain2buffer)                          
        # {'VPU': {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x000000000400A390>, 'ACK2RETURN': ' 1D-', 'COUNT2REFERENCE': 1 ...
        
    except:
        print('(Step 11Z/33) OF BUFFER4XI5TEST *** FAILED TO RETAIN BUFFER OF EACH DEVICE ', time4xi())  
                                   
   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS                          
    # ---------------------------------------------------------------------------------------------
    print('=' *33)          
    print('(Step 12A/33) OF BUFFER4XI5TEST - CREATING BUFFER4XI OBJECT')
    print('=' *33)  
    try:
        # ---------------------------------------------------------------------------------------------
        # CREATE WITH OBJECT                        
        # ---------------------------------------------------------------------------------------------        
        cc2xi = Buffer4Xi()
        print('(Step 12B/33) OF BUFFER4XI5TEST - CREATED BUFFER4XI OBJECT: ', cc2xi)                                  
        # <buffer4xi.Buffer4Xi object at 0x00000000040108D0> 
        
    except:
        print('(Step 12Z/33) OF BUFFER4XI5TEST *** FAILED TO CREATE BUFFER4XI OBJECT')
    
    # ---------------------------------------------------------------------------------------------
    # GET WITH METHOD                  
    # ---------------------------------------------------------------------------------------------          
    print('(Step 13A/33) OF BUFFER4XI5TEST - TRYING TO GET BUFFER INFO') 
    try:                               
        context6xi = cc2xi.get2bufferinfo()                                  
        print('(Step 13B/33) OF BUFFER4XI5TEST - GOT BUFFER INFO: ', context6xi)                                           
        # {'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK':  ...
        
    except:
        print('(Step 13Z/33) OF BUFFER4XI5TEST *** FAILED TO GET BUFFER INFO')   
     
    
    
    # ---------------------------------------------------------------------------------------------
    # SET WITH METHOD            
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 14A/33) OF BUFFER4XI5TEST - TRYING TO SET BUFFER ', time4xi())
    print('=' *33)       

          
    # ---------------------------------------------------------------------------------------------
    # (14) INITIALIZE TASK DICTIONARY                          
    # ---------------------------------------------------------------------------------------------            
    task4set2buffer = {}
    task4set2buffer ['APU'] = {}
    task4set2buffer ['BPU'] = {}
    task4set2buffer ['CPU'] = {}
    task4set2buffer ['DPU'] = {}
    task4set2buffer ['EPU'] = {}
    task4set2buffer ['FPU'] = {}
    task4set2buffer ['GPU'] = {}
    task4set2buffer ['HPU'] = {}
    task4set2buffer ['IPU'] = {}
    task4set2buffer ['JPU'] = {}
    task4set2buffer ['KPU'] = {}
    task4set2buffer ['LPU'] = {}
    task4set2buffer ['MPU'] = {}
    task4set2buffer ['NPU'] = {}
    task4set2buffer ['OPU'] = {}
    task4set2buffer ['PPU'] = {}
    task4set2buffer ['QPU'] = {}
    task4set2buffer ['RPU'] = {}
    task4set2buffer ['SPU'] = {}
    task4set2buffer ['TPU'] = {}
    task4set2buffer ['UPU'] = {}
    task4set2buffer ['VPU'] = {}
    task4set2buffer ['XPU'] = {}
    task4set2buffer ['WPU'] = {}
    task4set2buffer ['YPU'] = {}
    task4set2buffer ['ZPU'] = {}
    
    # ---------------------------------------------------------------------------------------------
    # (15) DEFINE CONTEXT                           
    # ---------------------------------------------------------------------------------------------         
    task4set2buffer ['APU'] ['CONTEXT'] = context2xi ['APU'] 
    task4set2buffer ['BPU'] ['CONTEXT'] = context2xi ['BPU'] 
    task4set2buffer ['CPU'] ['CONTEXT'] = context2xi ['CPU'] 
    task4set2buffer ['DPU'] ['CONTEXT'] = context2xi ['DPU'] 
    task4set2buffer ['EPU'] ['CONTEXT'] = context2xi ['EPU'] 
    task4set2buffer ['FPU'] ['CONTEXT'] = context2xi ['FPU'] 
    task4set2buffer ['GPU'] ['CONTEXT'] = context2xi ['GPU'] 
    task4set2buffer ['HPU'] ['CONTEXT'] = context2xi ['HPU'] 
    task4set2buffer ['IPU'] ['CONTEXT'] = context2xi ['IPU'] 
    task4set2buffer ['JPU'] ['CONTEXT'] = context2xi ['JPU'] 
    task4set2buffer ['KPU'] ['CONTEXT'] = context2xi ['KPU'] 
    task4set2buffer ['LPU'] ['CONTEXT'] = context2xi ['LPU'] 
    task4set2buffer ['MPU'] ['CONTEXT'] = context2xi ['MPU'] 
    task4set2buffer ['NPU'] ['CONTEXT'] = context2xi ['NPU'] 
    task4set2buffer ['OPU'] ['CONTEXT'] = context2xi ['OPU'] 
    task4set2buffer ['PPU'] ['CONTEXT'] = context2xi ['PPU'] 
    task4set2buffer ['QPU'] ['CONTEXT'] = context2xi ['QPU'] 
    task4set2buffer ['RPU'] ['CONTEXT'] = context2xi ['RPU'] 
    task4set2buffer ['SPU'] ['CONTEXT'] = context2xi ['SPU'] 
    task4set2buffer ['TPU'] ['CONTEXT'] = context2xi ['TPU'] 
    task4set2buffer ['UPU'] ['CONTEXT'] = context2xi ['UPU'] 
    task4set2buffer ['VPU'] ['CONTEXT'] = context2xi ['VPU'] 
    task4set2buffer ['XPU'] ['CONTEXT'] = context2xi ['XPU'] 
    task4set2buffer ['WPU'] ['CONTEXT'] = context2xi ['WPU'] 
    task4set2buffer ['YPU'] ['CONTEXT'] = context2xi ['YPU'] 
    task4set2buffer ['ZPU'] ['CONTEXT'] = context2xi ['ZPU']                            
    
    # ---------------------------------------------------------------------------------------------
    # (16) SET DEVICES                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 16A/33) OF BUFFER4XI5TEST - TRYING TO SET DEVICES', time4xi())
    print('=' *33)    
    try:
        
        device2xi = get2device4xi()
        print('(Step 16B/33) OF BUFFER4XI5TEST - GOT DEVICE4XI: ', device2xi) 
        # {'VPU': {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...
        
        task4set2buffer ['APU'] ['DEVICE'] = device2xi ['APU']
        task4set2buffer ['BPU'] ['DEVICE'] = device2xi ['BPU']
        task4set2buffer ['CPU'] ['DEVICE'] = device2xi ['CPU']
        task4set2buffer ['DPU'] ['DEVICE'] = device2xi ['DPU']
        task4set2buffer ['EPU'] ['DEVICE'] = device2xi ['EPU']
        task4set2buffer ['FPU'] ['DEVICE'] = device2xi ['FPU']
        task4set2buffer ['GPU'] ['DEVICE'] = device2xi ['GPU']
        task4set2buffer ['HPU'] ['DEVICE'] = device2xi ['HPU']
        task4set2buffer ['IPU'] ['DEVICE'] = device2xi ['IPU']
        task4set2buffer ['JPU'] ['DEVICE'] = device2xi ['JPU']
        task4set2buffer ['KPU'] ['DEVICE'] = device2xi ['KPU']
        task4set2buffer ['LPU'] ['DEVICE'] = device2xi ['LPU']
        task4set2buffer ['MPU'] ['DEVICE'] = device2xi ['MPU']
        task4set2buffer ['NPU'] ['DEVICE'] = device2xi ['NPU']
        task4set2buffer ['OPU'] ['DEVICE'] = device2xi ['OPU']
        task4set2buffer ['PPU'] ['DEVICE'] = device2xi ['PPU']
        task4set2buffer ['QPU'] ['DEVICE'] = device2xi ['QPU']
        task4set2buffer ['RPU'] ['DEVICE'] = device2xi ['RPU']
        task4set2buffer ['SPU'] ['DEVICE'] = device2xi ['SPU']
        task4set2buffer ['TPU'] ['DEVICE'] = device2xi ['TPU']
        task4set2buffer ['UPU'] ['DEVICE'] = device2xi ['UPU']
        task4set2buffer ['VPU'] ['DEVICE'] = device2xi ['VPU']
        task4set2buffer ['XPU'] ['DEVICE'] = device2xi ['XPU']
        task4set2buffer ['WPU'] ['DEVICE'] = device2xi ['WPU']
        task4set2buffer ['YPU'] ['DEVICE'] = device2xi ['YPU']
        task4set2buffer ['ZPU'] ['DEVICE'] = device2xi ['ZPU']
         
    except:
        print('(Step 16Z/33) OF BUFFER4XI5TEST *** FAILED TO SET DEVICES ', time4xi())    
    
    # ---------------------------------------------------------------------------------------------
    # (17) SET FLAGS                           
    # ---------------------------------------------------------------------------------------------         
    task4set2buffer ['APU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['BPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['CPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['DPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['EPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['FPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['GPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['HPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['IPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['JPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['KPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['LPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['MPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['NPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['OPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['PPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['QPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['RPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['SPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['TPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['UPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['VPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['XPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['WPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['YPU'] ['FLAGS'] = 0b00000011000000110000000100000011
    task4set2buffer ['ZPU'] ['FLAGS'] = 0b00000011000000110000000100000011  
                      
    
              
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO APU
    # ----------------------------------------------------------------------------------------- 
    arena2apu = None
    task4set2buffer ['APU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['APU'] ['SIZE']) 
    try:
        arena2apu = Arena4Xi(task4set2buffer ['APU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2APU IN ADDRESS: ', arena2apu)
        # <arena4xi.Arena4Xi object at 0x00000000052CBE10> 
    except:
        task4set2buffer ['APU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['APU'] ['SIZE']) 
        try:
            arena2apu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2APU IN ADDRESS: ', arena2apu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2APU *** ', time4xi())  
                   
    task4set2buffer ['APU'] ['POINTER2BUFFER'] = arena2apu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2APU POINTER IN TASK TO: ',task4set2buffer ['APU'] ['POINTER2BUFFER'])
              
                      
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO BPU
    # ----------------------------------------------------------------------------------------- 
    arena2bpu = None
    task4set2buffer ['BPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['BPU'] ['SIZE']) 
    try:
        arena2bpu = Arena4Xi(task4set2buffer ['BPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2BPU IN ADDRESS: ', arena2bpu)
        #  
    except:
        task4set2buffer ['BPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['BPU'] ['SIZE']) 
        try:
            arena2bpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2BPU IN ADDRESS: ', arena2bpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2BPU *** ', time4xi())  
                   
    task4set2buffer ['BPU'] ['POINTER2BUFFER'] = arena2bpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2BPU POINTER IN TASK TO: ',task4set2buffer ['BPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO CPU
    # ----------------------------------------------------------------------------------------- 
    arena2cpu = None
    task4set2buffer ['CPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['CPU'] ['SIZE']) 
    try:
        arena2cpu = Arena4Xi(task4set2buffer ['CPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2CPU IN ADDRESS: ', arena2cpu)
        #  
    except:
        task4set2buffer ['CPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['CPU'] ['SIZE']) 
        try:
            arena2cpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2CPU IN ADDRESS: ', arena2cpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2CPU *** ', time4xi())  
                   
    task4set2buffer ['CPU'] ['POINTER2BUFFER'] = arena2cpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2CPU POINTER IN TASK TO: ',task4set2buffer ['CPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO DPU
    # ----------------------------------------------------------------------------------------- 
    arena2dpu = None
    task4set2buffer ['DPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['DPU'] ['SIZE']) 
    try:
        arena2dpu = Arena4Xi(task4set2buffer ['DPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2DPU IN ADDRESS: ', arena2dpu)
        #  
    except:
        task4set2buffer ['DPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['DPU'] ['SIZE']) 
        try:
            arena2dpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2DPU IN ADDRESS: ', arena2dpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2DPU *** ', time4xi())  
                   
    task4set2buffer ['DPU'] ['POINTER2BUFFER'] = arena2dpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2DPU POINTER IN TASK TO: ',task4set2buffer ['DPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO EPU
    # ----------------------------------------------------------------------------------------- 
    arena2epu = None
    task4set2buffer ['EPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['EPU'] ['SIZE']) 
    try:
        arena2epu = Arena4Xi(task4set2buffer ['EPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2EPU IN ADDRESS: ', arena2epu)
        #  
    except:
        task4set2buffer ['EPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['EPU'] ['SIZE']) 
        try:
            arena2epu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2EPU IN ADDRESS: ', arena2epu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2EPU *** ', time4xi())  
                   
    task4set2buffer ['EPU'] ['POINTER2BUFFER'] = arena2epu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2EPU POINTER IN TASK TO: ',task4set2buffer ['EPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO FPU
    # ----------------------------------------------------------------------------------------- 
    arena2fpu = None
    task4set2buffer ['FPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['FPU'] ['SIZE']) 
    try:
        arena2fpu = Arena4Xi(task4set2buffer ['FPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2FPU IN ADDRESS: ', arena2fpu)
        #  
    except:
        task4set2buffer ['FPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['FPU'] ['SIZE']) 
        try:
            arena2fpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2FPU IN ADDRESS: ', arena2fpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2FPU *** ', time4xi())  
                   
    task4set2buffer ['FPU'] ['POINTER2BUFFER'] = arena2fpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2FPU POINTER IN TASK TO: ',task4set2buffer ['FPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO GPU
    # ----------------------------------------------------------------------------------------- 
    arena2gpu = None
    task4set2buffer ['GPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['GPU'] ['SIZE']) 
    try:
        arena2gpu = Arena4Xi(task4set2buffer ['GPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2GPU IN ADDRESS: ', arena2gpu)
        #  
    except:
        task4set2buffer ['GPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['GPU'] ['SIZE']) 
        try:
            arena2gpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2GPU IN ADDRESS: ', arena2gpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2GPU *** ', time4xi())  
                   
    task4set2buffer ['GPU'] ['POINTER2BUFFER'] = arena2gpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2GPU POINTER IN TASK TO: ',task4set2buffer ['GPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO HPU
    # ----------------------------------------------------------------------------------------- 
    arena2hpu = None
    task4set2buffer ['HPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['HPU'] ['SIZE']) 
    try:
        arena2hpu = Arena4Xi(task4set2buffer ['HPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2HPU IN ADDRESS: ', arena2hpu)
        #  
    except:
        task4set2buffer ['HPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['HPU'] ['SIZE']) 
        try:
            arena2hpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2HPU IN ADDRESS: ', arena2hpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2HPU *** ', time4xi())  
                   
    task4set2buffer ['HPU'] ['POINTER2BUFFER'] = arena2hpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2HPU POINTER IN TASK TO: ',task4set2buffer ['HPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO IPU
    # ----------------------------------------------------------------------------------------- 
    arena2ipu = None
    task4set2buffer ['IPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['IPU'] ['SIZE']) 
    try:
        arena2ipu = Arena4Xi(task4set2buffer ['IPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2IPU IN ADDRESS: ', arena2ipu)
        #  
    except:
        task4set2buffer ['IPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['IPU'] ['SIZE']) 
        try:
            arena2ipu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2IPU IN ADDRESS: ', arena2ipu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2IPU *** ', time4xi())  
                   
    task4set2buffer ['IPU'] ['POINTER2BUFFER'] = arena2ipu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2IPU POINTER IN TASK TO: ',task4set2buffer ['IPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO JPU
    # ----------------------------------------------------------------------------------------- 
    arena2jpu = None
    task4set2buffer ['JPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['JPU'] ['SIZE']) 
    try:
        arena2jpu = Arena4Xi(task4set2buffer ['JPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2JPU IN ADDRESS: ', arena2jpu)
        #  
    except:
        task4set2buffer ['JPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['JPU'] ['SIZE']) 
        try:
            arena2jpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2JPU IN ADDRESS: ', arena2jpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2JPU *** ', time4xi())  
                   
    task4set2buffer ['JPU'] ['POINTER2BUFFER'] = arena2jpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2JPU POINTER IN TASK TO: ',task4set2buffer ['JPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO KPU
    # ----------------------------------------------------------------------------------------- 
    arena2kpu = None
    task4set2buffer ['KPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['KPU'] ['SIZE']) 
    try:
        arena2kpu = Arena4Xi(task4set2buffer ['KPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2KPU IN ADDRESS: ', arena2kpu)
        #  
    except:
        task4set2buffer ['KPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['KPU'] ['SIZE']) 
        try:
            arena2kpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2KPU IN ADDRESS: ', arena2kpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2KPU *** ', time4xi())  
                   
    task4set2buffer ['KPU'] ['POINTER2BUFFER'] = arena2kpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2KPU POINTER IN TASK TO: ',task4set2buffer ['KPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO LPU
    # ----------------------------------------------------------------------------------------- 
    arena2lpu = None
    task4set2buffer ['LPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['LPU'] ['SIZE']) 
    try:
        arena2lpu = Arena4Xi(task4set2buffer ['LPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2LPU IN ADDRESS: ', arena2lpu)
        #  
    except:
        task4set2buffer ['LPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['LPU'] ['SIZE']) 
        try:
            arena2lpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2LPU IN ADDRESS: ', arena2lpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2LPU *** ', time4xi())  
                   
    task4set2buffer ['LPU'] ['POINTER2BUFFER'] = arena2lpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2LPU POINTER IN TASK TO: ',task4set2buffer ['LPU'] ['POINTER2BUFFER'])
    
                 
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO MPU
    # ----------------------------------------------------------------------------------------- 
    arena2mpu = None
    task4set2buffer ['MPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['MPU'] ['SIZE']) 
    try:
        arena2mpu = Arena4Xi(task4set2buffer ['MPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2MPU IN ADDRESS: ', arena2mpu)
        #  
    except:
        task4set2buffer ['MPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['MPU'] ['SIZE']) 
        try:
            arena2mpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2MPU IN ADDRESS: ', arena2mpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2MPU *** ', time4xi())  
                   
    task4set2buffer ['MPU'] ['POINTER2BUFFER'] = arena2mpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2MPU POINTER IN TASK TO: ',task4set2buffer ['MPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO NPU
    # ----------------------------------------------------------------------------------------- 
    arena2npu = None
    task4set2buffer ['NPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['NPU'] ['SIZE']) 
    try:
        arena2npu = Arena4Xi(task4set2buffer ['NPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2NPU IN ADDRESS: ', arena2npu)
        #  
    except:
        task4set2buffer ['NPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['NPU'] ['SIZE']) 
        try:
            arena2npu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2NPU IN ADDRESS: ', arena2npu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2NPU *** ', time4xi())  
                   
    task4set2buffer ['NPU'] ['POINTER2BUFFER'] = arena2npu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2NPU POINTER IN TASK TO: ',task4set2buffer ['NPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO OPU
    # ----------------------------------------------------------------------------------------- 
    arena2opu = None
    task4set2buffer ['OPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['OPU'] ['SIZE']) 
    try:
        arena2opu = Arena4Xi(task4set2buffer ['OPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2OPU IN ADDRESS: ', arena2opu)
        #  
    except:
        task4set2buffer ['OPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['OPU'] ['SIZE']) 
        try:
            arena2opu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2OPU IN ADDRESS: ', arena2opu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2OPU *** ', time4xi())  
                   
    task4set2buffer ['OPU'] ['POINTER2BUFFER'] = arena2opu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2OPU POINTER IN TASK TO: ',task4set2buffer ['OPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO PPU
    # ----------------------------------------------------------------------------------------- 
    arena2ppu = None
    task4set2buffer ['PPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['PPU'] ['SIZE']) 
    try:
        arena2ppu = Arena4Xi(task4set2buffer ['PPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2PPU IN ADDRESS: ', arena2ppu)
        #  
    except:
        task4set2buffer ['PPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['PPU'] ['SIZE']) 
        try:
            arena2ppu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2PPU IN ADDRESS: ', arena2ppu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2PPU *** ', time4xi())  
                   
    task4set2buffer ['PPU'] ['POINTER2BUFFER'] = arena2ppu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2PPU POINTER IN TASK TO: ',task4set2buffer ['PPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO QPU
    # ----------------------------------------------------------------------------------------- 
    arena2qpu = None
    task4set2buffer ['QPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['QPU'] ['SIZE']) 
    try:
        arena2qpu = Arena4Xi(task4set2buffer ['QPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2QPU IN ADDRESS: ', arena2qpu)
        #  
    except:
        task4set2buffer ['QPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['QPU'] ['SIZE']) 
        try:
            arena2qpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2QPU IN ADDRESS: ', arena2qpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2QPU *** ', time4xi())  
                   
    task4set2buffer ['QPU'] ['POINTER2BUFFER'] = arena2qpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2QPU POINTER IN TASK TO: ',task4set2buffer ['QPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO RPU
    # ----------------------------------------------------------------------------------------- 
    arena2rpu = None
    task4set2buffer ['RPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['RPU'] ['SIZE']) 
    try:
        arena2rpu = Arena4Xi(task4set2buffer ['RPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2RPU IN ADDRESS: ', arena2rpu)
        #  
    except:
        task4set2buffer ['RPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['RPU'] ['SIZE']) 
        try:
            arena2rpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2RPU IN ADDRESS: ', arena2rpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2RPU *** ', time4xi())  
                   
    task4set2buffer ['RPU'] ['POINTER2BUFFER'] = arena2rpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2RPU POINTER IN TASK TO: ',task4set2buffer ['RPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO SPU
    # ----------------------------------------------------------------------------------------- 
    arena2spu = None
    task4set2buffer ['SPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['SPU'] ['SIZE']) 
    try:
        arena2spu = Arena4Xi(task4set2buffer ['SPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2SPU IN ADDRESS: ', arena2spu)
        #  
    except:
        task4set2buffer ['SPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['SPU'] ['SIZE']) 
        try:
            arena2spu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2SPU IN ADDRESS: ', arena2spu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2SPU *** ', time4xi())  
                   
    task4set2buffer ['SPU'] ['POINTER2BUFFER'] = arena2spu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2SPU POINTER IN TASK TO: ',task4set2buffer ['SPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO TPU
    # ----------------------------------------------------------------------------------------- 
    arena2tpu = None
    task4set2buffer ['TPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['TPU'] ['SIZE']) 
    try:
        arena2tpu = Arena4Xi(task4set2buffer ['TPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2TPU IN ADDRESS: ', arena2tpu)
        #  
    except:
        task4set2buffer ['TPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['TPU'] ['SIZE']) 
        try:
            arena2tpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2TPU IN ADDRESS: ', arena2tpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2TPU *** ', time4xi())  
                   
    task4set2buffer ['TPU'] ['POINTER2BUFFER'] = arena2tpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2TPU POINTER IN TASK TO: ',task4set2buffer ['TPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO UPU
    # ----------------------------------------------------------------------------------------- 
    arena2upu = None
    task4set2buffer ['UPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['UPU'] ['SIZE']) 
    try:
        arena2upu = Arena4Xi(task4set2buffer ['UPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2UPU IN ADDRESS: ', arena2upu)
        #  
    except:
        task4set2buffer ['UPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['UPU'] ['SIZE']) 
        try:
            arena2upu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2UPU IN ADDRESS: ', arena2upu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2UPU *** ', time4xi())  
                   
    task4set2buffer ['UPU'] ['POINTER2BUFFER'] = arena2upu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2UPU POINTER IN TASK TO: ',task4set2buffer ['UPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO VPU
    # ----------------------------------------------------------------------------------------- 
    arena2vpu = None
    task4set2buffer ['VPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['VPU'] ['SIZE']) 
    try:
        arena2vpu = Arena4Xi(task4set2buffer ['VPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2VPU IN ADDRESS: ', arena2vpu)
        #  
    except:
        task4set2buffer ['VPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['VPU'] ['SIZE']) 
        try:
            arena2vpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2VPU IN ADDRESS: ', arena2vpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2VPU *** ', time4xi())  
                   
    task4set2buffer ['VPU'] ['POINTER2BUFFER'] = arena2vpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2VPU POINTER IN TASK TO: ',task4set2buffer ['VPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO WPU
    # ----------------------------------------------------------------------------------------- 
    arena2wpu = None
    task4set2buffer ['WPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['WPU'] ['SIZE']) 
    try:
        arena2wpu = Arena4Xi(task4set2buffer ['WPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2WPU IN ADDRESS: ', arena2wpu)
        #  
    except:
        task4set2buffer ['WPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['WPU'] ['SIZE']) 
        try:
            arena2wpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2WPU IN ADDRESS: ', arena2wpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2WPU *** ', time4xi())  
                   
    task4set2buffer ['WPU'] ['POINTER2BUFFER'] = arena2wpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2WPU POINTER IN TASK TO: ',task4set2buffer ['WPU'] ['POINTER2BUFFER'])
    
                  
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO XPU
    # ----------------------------------------------------------------------------------------- 
    arena2xpu = None
    task4set2buffer ['XPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['XPU'] ['SIZE']) 
    try:
        arena2xpu = Arena4Xi(task4set2buffer ['XPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2XPU IN ADDRESS: ', arena2xpu)
        #  
    except:
        task4set2buffer ['XPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['XPU'] ['SIZE']) 
        try:
            arena2xpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2XPU IN ADDRESS: ', arena2xpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2XPU *** ', time4xi())  
                   
    task4set2buffer ['XPU'] ['POINTER2BUFFER'] = arena2xpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2XPU POINTER IN TASK TO: ',task4set2buffer ['XPU'] ['POINTER2BUFFER'])
    
                 
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO YPU
    # ----------------------------------------------------------------------------------------- 
    arena2ypu = None
    task4set2buffer ['YPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['YPU'] ['SIZE']) 
    try:
        arena2ypu = Arena4Xi(task4set2buffer ['YPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2YPU IN ADDRESS: ', arena2ypu)
        #  
    except:
        task4set2buffer ['YPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['YPU'] ['SIZE']) 
        try:
            arena2ypu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2YPU IN ADDRESS: ', arena2ypu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2YPU *** ', time4xi())  
                   
    task4set2buffer ['YPU'] ['POINTER2BUFFER'] = arena2ypu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2YPU POINTER IN TASK TO: ',task4set2buffer ['YPU'] ['POINTER2BUFFER'])
        
    # -----------------------------------------------------------------------------------------
    # (18) ARENA TO ZPU
    # ----------------------------------------------------------------------------------------- 
    arena2zpu = None
    task4set2buffer ['ZPU'] ['SIZE'] = 8192 * 8
    print('(Step 18A1/33) OF BUFFER4XI5TEST - TRYING TO ALLOCATE BUFFER SIZE: ', task4set2buffer ['ZPU'] ['SIZE']) 
    try:
        arena2zpu = Arena4Xi(task4set2buffer ['ZPU'] ['SIZE'])
        print('(Step 18A2/33) OF BUFFER4XI5TEST - GOT ARENA2ZPU IN ADDRESS: ', arena2zpu)
        # <arena4xi.Arena4Xi object at 0x00000000055F4B70> 
    except:
        task4set2buffer ['ZPU'] ['SIZE'] = int(task4set2buffer ['SIZE']/4)                      # RE-ADJUST AND TRYGET LESS MEMORY
        print('(Step 18A3/33) OF BUFFER4XI5TEST - TRYING TO RE-ALLOCATE BUFFER SIZE: ', task4set2buffer ['ZPU'] ['SIZE']) 
        try:
            arena2zpu = Arena4Xi(task4set2buffer ['SIZE'])
            print('(Step 18A4/33) OF BUFFER4XI5TEST - GOT ARENA2ZPU IN ADDRESS: ', arena2zpu)
        except:
            print('(Step 18AZ/33) OF BUFFER4XI5TEST *** FAILED TO GET ARENA2ZPU *** ', time4xi())  
                   
    task4set2buffer ['ZPU'] ['POINTER2BUFFER'] = arena2zpu.buffer       
    print('(Step 18A5/33) OF BUFFER4XI5TEST - SET ARENA2ZPU POINTER IN TASK TO: ',task4set2buffer ['ZPU'] ['POINTER2BUFFER'])

                                                                                                                                                                                  
    # ---------------------------------------------------------------------------------------------
    # (26) SET BUFFERS TO ALL DEVICES                           
    # ---------------------------------------------------------------------------------------------
    print('(Step 26A/33) OF BUFFER4XI5TEST - TRYING SET BUFFERS TO ALL DEVICES  ', time4xi()) 
    try:                               
        response4set2buffer = cc2xi.set2buffer(task4set2buffer)                                                       
        print('(Step 26B/33) OF BUFFER4XI5TEST - RESPONSE4SET2BUFFER : ', response4set2buffer) 
        # {'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
        
    except:
        print('(Step 26Z/33) OF BUFFER4XI5TEST *** FAILED TO SET BUFFERS TO ALL DEVICES ', time4xi())   
        


                                                                                 
    # ---------------------------------------------------------------------------------------------
    # RELEASE BUFFERS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 27A/33) OF BUFFER4XI5TEST - RELEASING ', time4xi()) 
    print('=' *33)      
    
    task4release2buffer = {}
    task4release2buffer ['APU'] = {}
    task4release2buffer ['BPU'] = {}
    task4release2buffer ['CPU'] = {}
    task4release2buffer ['DPU'] = {}
    task4release2buffer ['EPU'] = {}
    task4release2buffer ['FPU'] = {}
    task4release2buffer ['GPU'] = {}
    task4release2buffer ['HPU'] = {}
    task4release2buffer ['IPU'] = {}
    task4release2buffer ['JPU'] = {}
    task4release2buffer ['KPU'] = {}
    task4release2buffer ['LPU'] = {}
    task4release2buffer ['MPU'] = {}
    task4release2buffer ['NPU'] = {}
    task4release2buffer ['OPU'] = {}
    task4release2buffer ['PPU'] = {}
    task4release2buffer ['QPU'] = {}
    task4release2buffer ['RPU'] = {}
    task4release2buffer ['SPU'] = {}
    task4release2buffer ['TPU'] = {}
    task4release2buffer ['UPU'] = {}
    task4release2buffer ['VPU'] = {}
    task4release2buffer ['XPU'] = {}
    task4release2buffer ['WPU'] = {}
    task4release2buffer ['YPU'] = {}
    task4release2buffer ['ZPU'] = {}
    
    task4release2buffer ['APU'] ['COUNT2REFERENCE'] = 1                                                                                                                       
    task4release2buffer ['BPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['CPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['DPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['EPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['FPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['GPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['HPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['IPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['JPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['KPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['LPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['MPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['NPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['OPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['PPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['QPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['RPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['SPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['TPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['UPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['VPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['XPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['WPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['YPU'] ['COUNT2REFERENCE'] = 1  
    task4release2buffer ['ZPU'] ['COUNT2REFERENCE'] = 1  
    
    
    try:
        release2xi = cc2xi.release2buffer(task4release2buffer)
    
        print('=' *33)          
        print('(Step 27B/33) OF BUFFER4XI5TEST - RELEASED: ', release2xi)   
        # {'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
        
        print('=' *33)
    except:
        print('(Step 27Z/33) OF BUFFER4XI5TEST *** FAILED TO RELEASE ', time4xi()) 
        
                                                                                   
    # ---------------------------------------------------------------------------------------------
    # RETAIN BUFFERS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 28A/33) OF BUFFER4XI5TEST - RETAIN ', time4xi())
    print('=' *33)      
    task4retain2buffer = {}
    task4retain2buffer ['APU'] = {}
    task4retain2buffer ['BPU'] = {}
    task4retain2buffer ['CPU'] = {}
    task4retain2buffer ['DPU'] = {}
    task4retain2buffer ['EPU'] = {}
    task4retain2buffer ['FPU'] = {}
    task4retain2buffer ['GPU'] = {}
    task4retain2buffer ['HPU'] = {}
    task4retain2buffer ['IPU'] = {}
    task4retain2buffer ['JPU'] = {}
    task4retain2buffer ['KPU'] = {}
    task4retain2buffer ['LPU'] = {}
    task4retain2buffer ['MPU'] = {}
    task4retain2buffer ['NPU'] = {}
    task4retain2buffer ['OPU'] = {}
    task4retain2buffer ['PPU'] = {}
    task4retain2buffer ['QPU'] = {}
    task4retain2buffer ['RPU'] = {}
    task4retain2buffer ['SPU'] = {}
    task4retain2buffer ['TPU'] = {}
    task4retain2buffer ['UPU'] = {}
    task4retain2buffer ['VPU'] = {}
    task4retain2buffer ['XPU'] = {}
    task4retain2buffer ['WPU'] = {}
    task4retain2buffer ['YPU'] = {}
    task4retain2buffer ['ZPU'] = {}
    
    task4retain2buffer ['APU'] ['COUNT2REFERENCE'] = 1                                                                                                                     
    task4retain2buffer ['BPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['CPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['DPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['EPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['FPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['GPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['HPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['IPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['JPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['KPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['LPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['MPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['NPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['OPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['PPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['QPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['RPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['SPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['TPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['UPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['VPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['XPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['WPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['YPU'] ['COUNT2REFERENCE'] = 1  
    task4retain2buffer ['ZPU'] ['COUNT2REFERENCE'] = 1    
    
    try:
        
        retain2xi = cc2xi.retain2buffer(task4retain2buffer)
    
        print('=' *33)          
        print('(Step 28B/33) OF BUFFER4XI5TEST - RETAINED: ', retain2xi) 
        # {'VPU': {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1 ...
        
        print('=' *33)
    except:
        print('(Step 28Z/33) OF BUFFER4XI5TEST *** FAILED TO RETAIN ', time4xi())            
        
                                                                                           
    # ---------------------------------------------------------------------------------------------
    # CREATE AGAIN BUFFERS WITH CLASS METHOD                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 29A/33) OF BUFFER4XI5TEST - CREATING BUFFERS', time4xi())
    print('=' *33)      
    
    try:
        create2xi = cc2xi.create2buffer(task4create2buffer)
    
        print('=' *33)          
        print('(Step 29B/33) OF BUFFER4XI5TEST - CREATED ', create2xi)  
        # {'VPU': {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x000000000400A390>, 'ACK2RETURN': ' 13B-15B-16B-17B-' ...
       
        print('=' *33)
    except:
        print('(Step 29Z/33) OF BUFFER4XI5TEST *** FAILED TO CREATE BUFFERS', time4xi())                        
 
                                                                                           
    # ---------------------------------------------------------------------------------------------
    # CREATE SUB-BUFFERS WITH CLASS METHOD - USING THE BUFFER CREATED                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 30A0/33) OF BUFFER4XI5TEST - TRYING TO CREATE SUB-BUFFERS FROM BUFFER create2xi', create2xi) 
    print('=' *33)      
    # {'VPU': {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003EAEF28>, 'ACK2RETURN': ' 13B-15B-16B-17B-' ...
    
    # ---------------------------------------------------------------------------------------------
    # (0) TASK DICTIONARY - FOR EACH DEVICE THERE IS A SUB-DICTIONARY                   
    # ---------------------------------------------------------------------------------------------          
    print('=' *33)          
    print('(Step 30A1/33) OF BUFFER4XI5TEST - TRYING TO INITIALIZE task4create2subbuffer', time4xi()) 
    print('=' *33)       
    task4create2subbuffer = {} 
    try:
            
        task4create2subbuffer ['APU'] = {}
        task4create2subbuffer ['BPU'] = {}
        task4create2subbuffer ['CPU'] = {}
        task4create2subbuffer ['DPU'] = {}
        task4create2subbuffer ['EPU'] = {}
        task4create2subbuffer ['FPU'] = {}
        task4create2subbuffer ['GPU'] = {}
        task4create2subbuffer ['HPU'] = {}
        task4create2subbuffer ['IPU'] = {}
        task4create2subbuffer ['JPU'] = {}
        task4create2subbuffer ['KPU'] = {}
        task4create2subbuffer ['LPU'] = {}
        task4create2subbuffer ['MPU'] = {}
        task4create2subbuffer ['NPU'] = {}
        task4create2subbuffer ['OPU'] = {}
        task4create2subbuffer ['PPU'] = {}
        task4create2subbuffer ['QPU'] = {}
        task4create2subbuffer ['RPU'] = {}
        task4create2subbuffer ['SPU'] = {}
        task4create2subbuffer ['TPU'] = {}
        task4create2subbuffer ['UPU'] = {}
        task4create2subbuffer ['VPU'] = {}
        task4create2subbuffer ['XPU'] = {}
        task4create2subbuffer ['WPU'] = {}
        task4create2subbuffer ['YPU'] = {}
        task4create2subbuffer ['ZPU'] = {}
        print('(Step 30A2/33) OF BUFFER4XI5TEST - INITIALIZED task4create2subbuffer', task4create2subbuffer)
        
    except:
        print('(Step 30Z2/33) OF BUFFER4XI5TEST *** FAILED TO INITIALIZE task4create2subbuffer', task4create2subbuffer)       
 
    # ---------------------------------------------------------------------------------------------
    # (1) BUFFER OBJECT - REQUIRED                     
    # ---------------------------------------------------------------------------------------------         
    print('=' *33)          
    print('(Step 30A1/33) OF BUFFER4XI5TEST - TRYING TO SET task4create2subbuffer from create2xi: ', create2xi)
    print('=' *33)       
    try:
        task4create2subbuffer ['APU'] ['BUFFER'] = create2xi ['APU']
        task4create2subbuffer ['BPU'] ['BUFFER'] = create2xi ['BPU']
        task4create2subbuffer ['CPU'] ['BUFFER'] = create2xi ['CPU']
        task4create2subbuffer ['DPU'] ['BUFFER'] = create2xi ['DPU']
        task4create2subbuffer ['EPU'] ['BUFFER'] = create2xi ['EPU']
        task4create2subbuffer ['FPU'] ['BUFFER'] = create2xi ['FPU']
        task4create2subbuffer ['GPU'] ['BUFFER'] = create2xi ['GPU']
        task4create2subbuffer ['HPU'] ['BUFFER'] = create2xi ['HPU']
        task4create2subbuffer ['IPU'] ['BUFFER'] = create2xi ['IPU']
        task4create2subbuffer ['JPU'] ['BUFFER'] = create2xi ['JPU']
        task4create2subbuffer ['KPU'] ['BUFFER'] = create2xi ['KPU']
        task4create2subbuffer ['LPU'] ['BUFFER'] = create2xi ['LPU']
        task4create2subbuffer ['MPU'] ['BUFFER'] = create2xi ['MPU']
        task4create2subbuffer ['NPU'] ['BUFFER'] = create2xi ['NPU']
        task4create2subbuffer ['OPU'] ['BUFFER'] = create2xi ['OPU']
        task4create2subbuffer ['PPU'] ['BUFFER'] = create2xi ['PPU']
        task4create2subbuffer ['QPU'] ['BUFFER'] = create2xi ['QPU']
        task4create2subbuffer ['RPU'] ['BUFFER'] = create2xi ['RPU']
        task4create2subbuffer ['SPU'] ['BUFFER'] = create2xi ['SPU']
        task4create2subbuffer ['TPU'] ['BUFFER'] = create2xi ['TPU']
        task4create2subbuffer ['UPU'] ['BUFFER'] = create2xi ['UPU']
        task4create2subbuffer ['VPU'] ['BUFFER'] = create2xi ['VPU']
        task4create2subbuffer ['XPU'] ['BUFFER'] = create2xi ['XPU']
        task4create2subbuffer ['WPU'] ['BUFFER'] = create2xi ['WPU']
        task4create2subbuffer ['YPU'] ['BUFFER'] = create2xi ['YPU']
        task4create2subbuffer ['ZPU'] ['BUFFER'] = create2xi ['ZPU']
        print('(Step 30C/33) OF BUFFER4XI5TEST - SET task4create2subbuffer: ', task4create2subbuffer)
        # 
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED SET task4create2subbuffer from create2xi: ', create2xi)
        # 
            
    # ---------------------------------------------------------------------------------------------
    # (2) FLAGS - REQUIRED - TAKEN FROM BUFFER                
    # ---------------------------------------------------------------------------------------------             
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE FLAGS ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['FLAGS'] = create2xi ['APU'] ['FLAGS']
        task4create2subbuffer ['BPU'] ['FLAGS'] = create2xi ['BPU'] ['FLAGS']
        task4create2subbuffer ['CPU'] ['FLAGS'] = create2xi ['CPU'] ['FLAGS']
        task4create2subbuffer ['DPU'] ['FLAGS'] = create2xi ['DPU'] ['FLAGS']
        task4create2subbuffer ['EPU'] ['FLAGS'] = create2xi ['EPU'] ['FLAGS']
        task4create2subbuffer ['FPU'] ['FLAGS'] = create2xi ['FPU'] ['FLAGS']
        task4create2subbuffer ['GPU'] ['FLAGS'] = create2xi ['GPU'] ['FLAGS']
        task4create2subbuffer ['HPU'] ['FLAGS'] = create2xi ['HPU'] ['FLAGS']
        task4create2subbuffer ['IPU'] ['FLAGS'] = create2xi ['IPU'] ['FLAGS']
        task4create2subbuffer ['JPU'] ['FLAGS'] = create2xi ['JPU'] ['FLAGS']
        task4create2subbuffer ['KPU'] ['FLAGS'] = create2xi ['KPU'] ['FLAGS']
        task4create2subbuffer ['LPU'] ['FLAGS'] = create2xi ['LPU'] ['FLAGS']
        task4create2subbuffer ['MPU'] ['FLAGS'] = create2xi ['MPU'] ['FLAGS']
        task4create2subbuffer ['NPU'] ['FLAGS'] = create2xi ['NPU'] ['FLAGS']
        task4create2subbuffer ['OPU'] ['FLAGS'] = create2xi ['OPU'] ['FLAGS']
        task4create2subbuffer ['PPU'] ['FLAGS'] = create2xi ['PPU'] ['FLAGS']
        task4create2subbuffer ['QPU'] ['FLAGS'] = create2xi ['QPU'] ['FLAGS']
        task4create2subbuffer ['RPU'] ['FLAGS'] = create2xi ['RPU'] ['FLAGS']
        task4create2subbuffer ['SPU'] ['FLAGS'] = create2xi ['SPU'] ['FLAGS']
        task4create2subbuffer ['TPU'] ['FLAGS'] = create2xi ['TPU'] ['FLAGS']
        task4create2subbuffer ['UPU'] ['FLAGS'] = create2xi ['UPU'] ['FLAGS']
        task4create2subbuffer ['VPU'] ['FLAGS'] = create2xi ['VPU'] ['FLAGS']
        task4create2subbuffer ['XPU'] ['FLAGS'] = create2xi ['XPU'] ['FLAGS']
        task4create2subbuffer ['WPU'] ['FLAGS'] = create2xi ['WPU'] ['FLAGS']
        task4create2subbuffer ['YPU'] ['FLAGS'] = create2xi ['YPU'] ['FLAGS']
        task4create2subbuffer ['ZPU'] ['FLAGS'] = create2xi ['ZPU'] ['FLAGS']
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED FLAGS ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED DEFINE FLAGS ', time4xi()) 
               
    # ---------------------------------------------------------------------------------------------
    # (3) TYPE - REQUIRED                   
    # ---------------------------------------------------------------------------------------------                     
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE TYPE ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['BPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['CPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['DPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['EPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['FPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['GPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['HPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['IPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['JPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['KPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['LPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['MPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['NPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['OPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['PPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['QPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['RPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['SPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['TPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['UPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['VPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['XPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['WPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['YPU'] ['TYPE'] = 'REGION'
        task4create2subbuffer ['ZPU'] ['TYPE'] = 'REGION'
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED TYPE ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED DEFINE TYPE ', time4xi()) 
   
    # ---------------------------------------------------------------------------------------------
    # (4) INFO - REQUIRED - NONE GIVEN BECAUSE DICTIONARY IS THE INFO STRUCTURE                 
    # ---------------------------------------------------------------------------------------------                     
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE INFO ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['INFO'] = None
        task4create2subbuffer ['BPU'] ['INFO'] = None
        task4create2subbuffer ['CPU'] ['INFO'] = None
        task4create2subbuffer ['DPU'] ['INFO'] = None
        task4create2subbuffer ['EPU'] ['INFO'] = None
        task4create2subbuffer ['FPU'] ['INFO'] = None
        task4create2subbuffer ['GPU'] ['INFO'] = None
        task4create2subbuffer ['HPU'] ['INFO'] = None
        task4create2subbuffer ['IPU'] ['INFO'] = None
        task4create2subbuffer ['JPU'] ['INFO'] = None
        task4create2subbuffer ['KPU'] ['INFO'] = None
        task4create2subbuffer ['LPU'] ['INFO'] = None
        task4create2subbuffer ['MPU'] ['INFO'] = None
        task4create2subbuffer ['NPU'] ['INFO'] = None
        task4create2subbuffer ['OPU'] ['INFO'] = None
        task4create2subbuffer ['PPU'] ['INFO'] = None
        task4create2subbuffer ['QPU'] ['INFO'] = None
        task4create2subbuffer ['RPU'] ['INFO'] = None
        task4create2subbuffer ['SPU'] ['INFO'] = None
        task4create2subbuffer ['TPU'] ['INFO'] = None
        task4create2subbuffer ['UPU'] ['INFO'] = None
        task4create2subbuffer ['VPU'] ['INFO'] = None
        task4create2subbuffer ['XPU'] ['INFO'] = None
        task4create2subbuffer ['WPU'] ['INFO'] = None
        task4create2subbuffer ['YPU'] ['INFO'] = None
        task4create2subbuffer ['ZPU'] ['INFO'] = None
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED INFO ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED DEFINE INFO ', time4xi()) 
        
    # ---------------------------------------------------------------------------------------------
    # (5) ERROR CODE - REQUIRED                  
    # ---------------------------------------------------------------------------------------------                  
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE ERROR CODE ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['BPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['CPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['DPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['EPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['FPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['GPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['HPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['IPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['JPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['KPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['LPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['MPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['NPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['OPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['PPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['QPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['RPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['SPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['TPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['UPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['VPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['XPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['WPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['YPU'] ['CODE2ERROR'] = 0
        task4create2subbuffer ['ZPU'] ['CODE2ERROR'] = 0
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED ERROR CODE ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED DEFINE ERROR CODE ', time4xi()) 
        
    # ---------------------------------------------------------------------------------------------
    # (6) DATA2CALLBACK - EXTRA - TAKEN FROM BUFFER                  
    # ---------------------------------------------------------------------------------------------                                                      
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO SET DATA2CALLBACK ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['DATA2CALLBACK'] = create2xi ['APU'] ['DATA2CALLBACK']
        task4create2subbuffer ['BPU'] ['DATA2CALLBACK'] = create2xi ['BPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['CPU'] ['DATA2CALLBACK'] = create2xi ['CPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['DPU'] ['DATA2CALLBACK'] = create2xi ['DPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['EPU'] ['DATA2CALLBACK'] = create2xi ['EPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['FPU'] ['DATA2CALLBACK'] = create2xi ['FPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['GPU'] ['DATA2CALLBACK'] = create2xi ['GPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['HPU'] ['DATA2CALLBACK'] = create2xi ['HPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['IPU'] ['DATA2CALLBACK'] = create2xi ['IPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['JPU'] ['DATA2CALLBACK'] = create2xi ['JPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['KPU'] ['DATA2CALLBACK'] = create2xi ['KPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['LPU'] ['DATA2CALLBACK'] = create2xi ['LPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['MPU'] ['DATA2CALLBACK'] = create2xi ['MPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['NPU'] ['DATA2CALLBACK'] = create2xi ['NPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['OPU'] ['DATA2CALLBACK'] = create2xi ['OPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['PPU'] ['DATA2CALLBACK'] = create2xi ['PPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['QPU'] ['DATA2CALLBACK'] = create2xi ['QPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['RPU'] ['DATA2CALLBACK'] = create2xi ['RPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['SPU'] ['DATA2CALLBACK'] = create2xi ['SPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['TPU'] ['DATA2CALLBACK'] = create2xi ['TPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['UPU'] ['DATA2CALLBACK'] = create2xi ['UPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['VPU'] ['DATA2CALLBACK'] = create2xi ['VPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['XPU'] ['DATA2CALLBACK'] = create2xi ['XPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['WPU'] ['DATA2CALLBACK'] = create2xi ['WPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['YPU'] ['DATA2CALLBACK'] = create2xi ['YPU'] ['DATA2CALLBACK']
        task4create2subbuffer ['ZPU'] ['DATA2CALLBACK'] = create2xi ['ZPU'] ['DATA2CALLBACK']
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - SET DATA2CALLBACK - TASK4CREATE2SUBBUFFER: ', task4create2subbuffer, " CREATE2XI:", create2xi)
        # 
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST ** YIELDED SETTING DATA2CALLBACK - CREATE2XI: ', create2xi)
    
    # ---------------------------------------------------------------------------------------------
    # (7) FUNCTION2CALLBACK - EXTRA - TAKEN FROM BUFFER (TO BE EXPLORED, IF IT IS A GOOD IDEA)                  
    # ---------------------------------------------------------------------------------------------        
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE FUNCTION2CALLBACK ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['FUNCTION2CALLBACK'] = create2xi ['APU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['BPU'] ['FUNCTION2CALLBACK'] = create2xi ['BPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['CPU'] ['FUNCTION2CALLBACK'] = create2xi ['CPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['DPU'] ['FUNCTION2CALLBACK'] = create2xi ['DPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['EPU'] ['FUNCTION2CALLBACK'] = create2xi ['EPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['FPU'] ['FUNCTION2CALLBACK'] = create2xi ['FPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['GPU'] ['FUNCTION2CALLBACK'] = create2xi ['GPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['HPU'] ['FUNCTION2CALLBACK'] = create2xi ['HPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['IPU'] ['FUNCTION2CALLBACK'] = create2xi ['IPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['JPU'] ['FUNCTION2CALLBACK'] = create2xi ['JPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['KPU'] ['FUNCTION2CALLBACK'] = create2xi ['KPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['LPU'] ['FUNCTION2CALLBACK'] = create2xi ['LPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['MPU'] ['FUNCTION2CALLBACK'] = create2xi ['MPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['NPU'] ['FUNCTION2CALLBACK'] = create2xi ['NPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['OPU'] ['FUNCTION2CALLBACK'] = create2xi ['OPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['PPU'] ['FUNCTION2CALLBACK'] = create2xi ['PPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['QPU'] ['FUNCTION2CALLBACK'] = create2xi ['QPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['RPU'] ['FUNCTION2CALLBACK'] = create2xi ['RPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['SPU'] ['FUNCTION2CALLBACK'] = create2xi ['SPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['TPU'] ['FUNCTION2CALLBACK'] = create2xi ['TPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['UPU'] ['FUNCTION2CALLBACK'] = create2xi ['UPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['VPU'] ['FUNCTION2CALLBACK'] = create2xi ['VPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['XPU'] ['FUNCTION2CALLBACK'] = create2xi ['XPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['WPU'] ['FUNCTION2CALLBACK'] = create2xi ['WPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['YPU'] ['FUNCTION2CALLBACK'] = create2xi ['YPU'] ['FUNCTION2CALLBACK']
        task4create2subbuffer ['ZPU'] ['FUNCTION2CALLBACK'] = create2xi ['ZPU'] ['FUNCTION2CALLBACK']
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED FUNCTION2CALLBACK ', time4xi())
        # 
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST ** YIELDED DEFINING FUNCTION2CALLBACK ', time4xi())     
        # 06:12:12 05/24/11 Pacific Daylight Time
        
    # ---------------------------------------------------------------------------------------------
    # (8) CONTEXT - EXTRA - TAKEN FROM BUFFER (TO BE EXPLORED, IF IT IS A GOOD IDEA)                  
    # ---------------------------------------------------------------------------------------------        
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE CONTEXT ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['CONTEXT'] = create2xi ['APU'] ['CONTEXT']
        task4create2subbuffer ['BPU'] ['CONTEXT'] = create2xi ['BPU'] ['CONTEXT']
        task4create2subbuffer ['CPU'] ['CONTEXT'] = create2xi ['CPU'] ['CONTEXT']
        task4create2subbuffer ['DPU'] ['CONTEXT'] = create2xi ['DPU'] ['CONTEXT']
        task4create2subbuffer ['EPU'] ['CONTEXT'] = create2xi ['EPU'] ['CONTEXT']
        task4create2subbuffer ['FPU'] ['CONTEXT'] = create2xi ['FPU'] ['CONTEXT']
        task4create2subbuffer ['GPU'] ['CONTEXT'] = create2xi ['GPU'] ['CONTEXT']
        task4create2subbuffer ['HPU'] ['CONTEXT'] = create2xi ['HPU'] ['CONTEXT']
        task4create2subbuffer ['IPU'] ['CONTEXT'] = create2xi ['IPU'] ['CONTEXT']
        task4create2subbuffer ['JPU'] ['CONTEXT'] = create2xi ['JPU'] ['CONTEXT']
        task4create2subbuffer ['KPU'] ['CONTEXT'] = create2xi ['KPU'] ['CONTEXT']
        task4create2subbuffer ['LPU'] ['CONTEXT'] = create2xi ['LPU'] ['CONTEXT']
        task4create2subbuffer ['MPU'] ['CONTEXT'] = create2xi ['MPU'] ['CONTEXT']
        task4create2subbuffer ['NPU'] ['CONTEXT'] = create2xi ['NPU'] ['CONTEXT']
        task4create2subbuffer ['OPU'] ['CONTEXT'] = create2xi ['OPU'] ['CONTEXT']
        task4create2subbuffer ['PPU'] ['CONTEXT'] = create2xi ['PPU'] ['CONTEXT']
        task4create2subbuffer ['QPU'] ['CONTEXT'] = create2xi ['QPU'] ['CONTEXT']
        task4create2subbuffer ['RPU'] ['CONTEXT'] = create2xi ['RPU'] ['CONTEXT']
        task4create2subbuffer ['SPU'] ['CONTEXT'] = create2xi ['SPU'] ['CONTEXT']
        task4create2subbuffer ['TPU'] ['CONTEXT'] = create2xi ['TPU'] ['CONTEXT']
        task4create2subbuffer ['UPU'] ['CONTEXT'] = create2xi ['UPU'] ['CONTEXT']
        task4create2subbuffer ['VPU'] ['CONTEXT'] = create2xi ['VPU'] ['CONTEXT']
        task4create2subbuffer ['XPU'] ['CONTEXT'] = create2xi ['XPU'] ['CONTEXT']
        task4create2subbuffer ['WPU'] ['CONTEXT'] = create2xi ['WPU'] ['CONTEXT']
        task4create2subbuffer ['YPU'] ['CONTEXT'] = create2xi ['YPU'] ['CONTEXT']
        task4create2subbuffer ['ZPU'] ['CONTEXT'] = create2xi ['ZPU'] ['CONTEXT']
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED CONTEXT ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST ** YIELDED DEFINING CONTEXT ', time4xi())  
        
    # ---------------------------------------------------------------------------------------------
    # (9) DEVICE - DEVICE EXTRA - TAKEN FROM BUFFER (TO BE EXPLORED, IF IT IS A GOOD IDEA)                    
    # ---------------------------------------------------------------------------------------------        
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE DEVICE ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['DEVICE'] = create2xi ['APU'] ['DEVICE']
        task4create2subbuffer ['BPU'] ['DEVICE'] = create2xi ['BPU'] ['DEVICE']
        task4create2subbuffer ['CPU'] ['DEVICE'] = create2xi ['CPU'] ['DEVICE']
        task4create2subbuffer ['DPU'] ['DEVICE'] = create2xi ['DPU'] ['DEVICE']
        task4create2subbuffer ['EPU'] ['DEVICE'] = create2xi ['EPU'] ['DEVICE']
        task4create2subbuffer ['FPU'] ['DEVICE'] = create2xi ['FPU'] ['DEVICE']
        task4create2subbuffer ['GPU'] ['DEVICE'] = create2xi ['GPU'] ['DEVICE']
        task4create2subbuffer ['HPU'] ['DEVICE'] = create2xi ['HPU'] ['DEVICE']
        task4create2subbuffer ['IPU'] ['DEVICE'] = create2xi ['IPU'] ['DEVICE']
        task4create2subbuffer ['JPU'] ['DEVICE'] = create2xi ['JPU'] ['DEVICE']
        task4create2subbuffer ['KPU'] ['DEVICE'] = create2xi ['KPU'] ['DEVICE']
        task4create2subbuffer ['LPU'] ['DEVICE'] = create2xi ['LPU'] ['DEVICE']
        task4create2subbuffer ['MPU'] ['DEVICE'] = create2xi ['MPU'] ['DEVICE']
        task4create2subbuffer ['NPU'] ['DEVICE'] = create2xi ['NPU'] ['DEVICE']
        task4create2subbuffer ['OPU'] ['DEVICE'] = create2xi ['OPU'] ['DEVICE']
        task4create2subbuffer ['PPU'] ['DEVICE'] = create2xi ['PPU'] ['DEVICE']
        task4create2subbuffer ['QPU'] ['DEVICE'] = create2xi ['QPU'] ['DEVICE']
        task4create2subbuffer ['RPU'] ['DEVICE'] = create2xi ['RPU'] ['DEVICE']
        task4create2subbuffer ['SPU'] ['DEVICE'] = create2xi ['SPU'] ['DEVICE']
        task4create2subbuffer ['TPU'] ['DEVICE'] = create2xi ['TPU'] ['DEVICE']
        task4create2subbuffer ['UPU'] ['DEVICE'] = create2xi ['UPU'] ['DEVICE']
        task4create2subbuffer ['VPU'] ['DEVICE'] = create2xi ['VPU'] ['DEVICE']
        task4create2subbuffer ['XPU'] ['DEVICE'] = create2xi ['XPU'] ['DEVICE']
        task4create2subbuffer ['WPU'] ['DEVICE'] = create2xi ['WPU'] ['DEVICE']
        task4create2subbuffer ['YPU'] ['DEVICE'] = create2xi ['YPU'] ['DEVICE']
        task4create2subbuffer ['ZPU'] ['DEVICE'] = create2xi ['ZPU'] ['DEVICE']
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED DEVICE ', time4xi())
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST ** YIELDED DEFINING ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
        
    # ---------------------------------------------------------------------------------------------
    # (10) - REFERENCE COUNT - EXTRA - FOR RELEASE AND RETAIN           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE REFERENCE COUNT ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['BPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['CPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['DPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['EPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['FPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['GPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['HPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['IPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['JPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['KPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['LPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['MPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['NPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['OPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['PPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['QPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['RPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['SPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['TPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['UPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['VPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['XPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['WPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['YPU'] ['COUNT2REFERENCE'] = 0
        task4create2subbuffer ['ZPU'] ['COUNT2REFERENCE'] = 0
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED REFERENCE COUNT ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED DEFINE REFERENCE COUNT ', time4xi())   
        
    # ---------------------------------------------------------------------------------------------
    # (11) BUFFER POINTER - EXTRA - TAKEN FROM BUFFER         
    # --------------------------------------------------------------------------------------------- 
    print('=' *33)          
    print('(Step 30B/33) OF BUFFER4XI5TEST - TRYING TO DEFINE BUFFER POINTER ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['POINTER2BUFFER'] = create2xi ['APU'] ['POINTER2BUFFER']
        task4create2subbuffer ['BPU'] ['POINTER2BUFFER'] = create2xi ['BPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['CPU'] ['POINTER2BUFFER'] = create2xi ['CPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['DPU'] ['POINTER2BUFFER'] = create2xi ['DPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['EPU'] ['POINTER2BUFFER'] = create2xi ['EPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['FPU'] ['POINTER2BUFFER'] = create2xi ['FPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['GPU'] ['POINTER2BUFFER'] = create2xi ['GPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['HPU'] ['POINTER2BUFFER'] = create2xi ['HPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['IPU'] ['POINTER2BUFFER'] = create2xi ['IPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['JPU'] ['POINTER2BUFFER'] = create2xi ['JPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['KPU'] ['POINTER2BUFFER'] = create2xi ['KPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['LPU'] ['POINTER2BUFFER'] = create2xi ['LPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['MPU'] ['POINTER2BUFFER'] = create2xi ['MPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['NPU'] ['POINTER2BUFFER'] = create2xi ['NPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['OPU'] ['POINTER2BUFFER'] = create2xi ['OPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['PPU'] ['POINTER2BUFFER'] = create2xi ['PPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['QPU'] ['POINTER2BUFFER'] = create2xi ['QPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['RPU'] ['POINTER2BUFFER'] = create2xi ['RPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['SPU'] ['POINTER2BUFFER'] = create2xi ['SPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['TPU'] ['POINTER2BUFFER'] = create2xi ['TPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['UPU'] ['POINTER2BUFFER'] = create2xi ['UPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['VPU'] ['POINTER2BUFFER'] = create2xi ['VPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['XPU'] ['POINTER2BUFFER'] = create2xi ['XPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['WPU'] ['POINTER2BUFFER'] = create2xi ['WPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['YPU'] ['POINTER2BUFFER'] = create2xi ['YPU'] ['POINTER2BUFFER']
        task4create2subbuffer ['ZPU'] ['POINTER2BUFFER'] = create2xi ['ZPU'] ['POINTER2BUFFER']
                                                                                                                                                                                                        
        print('(Step 30C/33) OF BUFFER4XI5TEST - DEFINED BUFFER POINTER ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 30Z1/33) OF BUFFER4XI5TEST *** FAILED DEFINE BUFFER POINTER ', time4xi()) 
            
        
    # ---------------------------------------------------------------------------------------------
    # (12) REGION OFFSET - REQUIRED                   
    # ---------------------------------------------------------------------------------------------                 
    print('=' *33)          
    print('(Step 31A/33) OF BUFFER4XI5TEST - TRYING TO DEFINE OFFSET ', time4xi())
    print('=' *33)         
    try:
        task4create2subbuffer ['APU'] ['OFFSET'] = 8192
        task4create2subbuffer ['BPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['CPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['DPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['EPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['FPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['GPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['HPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['IPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['JPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['KPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['LPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['MPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['NPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['OPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['PPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['QPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['RPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['SPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['TPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['UPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['VPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['XPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['WPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['YPU'] ['OFFSET'] = 8192
        task4create2subbuffer ['ZPU'] ['OFFSET'] = 8192
                                                                                                                                                                                                        
        print('(Step 31B/33) OF BUFFER4XI5TEST - DEFINED OFFSET ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 31Z33) OF BUFFER4XI5TEST *** FAILED TO DEFINE OFFSET ', time4xi()) 
        
    # ---------------------------------------------------------------------------------------------
    # (13) REGION SIZE - REQUIRED - CALCULATED FROM BUFFER SIZE OF EACH DEVICE          
    # --------------------------------------------------------------------------------------------- 
    print('=' *33)          
    print('(Step 32A/33) OF BUFFER4XI5TEST - TRYING TO DEFINE REGION SIZE ', time4xi()) 
    print('=' *33)        
    try:
        task4create2subbuffer ['APU'] ['SIZE'] = int(create2xi ['APU'] ['SIZE'] / 8)
        task4create2subbuffer ['BPU'] ['SIZE'] = int(create2xi ['BPU'] ['SIZE'] / 8)
        task4create2subbuffer ['CPU'] ['SIZE'] = int(create2xi ['CPU'] ['SIZE'] / 8)
        task4create2subbuffer ['DPU'] ['SIZE'] = int(create2xi ['DPU'] ['SIZE'] / 8)
        task4create2subbuffer ['EPU'] ['SIZE'] = int(create2xi ['EPU'] ['SIZE'] / 8)
        task4create2subbuffer ['FPU'] ['SIZE'] = int(create2xi ['FPU'] ['SIZE'] / 8)
        task4create2subbuffer ['GPU'] ['SIZE'] = int(create2xi ['GPU'] ['SIZE'] / 8)
        task4create2subbuffer ['HPU'] ['SIZE'] = int(create2xi ['HPU'] ['SIZE'] / 8)
        task4create2subbuffer ['IPU'] ['SIZE'] = int(create2xi ['IPU'] ['SIZE'] / 8)
        task4create2subbuffer ['JPU'] ['SIZE'] = int(create2xi ['JPU'] ['SIZE'] / 8)
        task4create2subbuffer ['KPU'] ['SIZE'] = int(create2xi ['KPU'] ['SIZE'] / 8)
        task4create2subbuffer ['LPU'] ['SIZE'] = int(create2xi ['LPU'] ['SIZE'] / 8)
        task4create2subbuffer ['MPU'] ['SIZE'] = int(create2xi ['MPU'] ['SIZE'] / 8)
        task4create2subbuffer ['NPU'] ['SIZE'] = int(create2xi ['NPU'] ['SIZE'] / 8)
        task4create2subbuffer ['OPU'] ['SIZE'] = int(create2xi ['OPU'] ['SIZE'] / 8)
        task4create2subbuffer ['PPU'] ['SIZE'] = int(create2xi ['PPU'] ['SIZE'] / 8)
        task4create2subbuffer ['QPU'] ['SIZE'] = int(create2xi ['QPU'] ['SIZE'] / 8)
        task4create2subbuffer ['RPU'] ['SIZE'] = int(create2xi ['RPU'] ['SIZE'] / 8)
        task4create2subbuffer ['SPU'] ['SIZE'] = int(create2xi ['SPU'] ['SIZE'] / 8)
        task4create2subbuffer ['TPU'] ['SIZE'] = int(create2xi ['TPU'] ['SIZE'] / 8)
        task4create2subbuffer ['UPU'] ['SIZE'] = int(create2xi ['UPU'] ['SIZE'] / 8)
        task4create2subbuffer ['VPU'] ['SIZE'] = int(create2xi ['VPU'] ['SIZE'] / 8)
        task4create2subbuffer ['XPU'] ['SIZE'] = int(create2xi ['XPU'] ['SIZE'] / 8)
        task4create2subbuffer ['WPU'] ['SIZE'] = int(create2xi ['WPU'] ['SIZE'] / 8)
        task4create2subbuffer ['YPU'] ['SIZE'] = int(create2xi ['YPU'] ['SIZE'] / 8)
        task4create2subbuffer ['ZPU'] ['SIZE'] = int(create2xi ['ZPU'] ['SIZE'] / 8)
                                                                                                                                                                                                        
        print('(Step 32B/33) OF BUFFER4XI5TEST - DEFINED REGION SIZE ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
    except:
        print('(Step 32Z1/33) OF BUFFER4XI5TEST *** FAILED TO DEFINE REGION SIZE ', time4xi())              
    
    # ---------------------------------------------------------------------------------------------
    # SUB-BUFFER CREATION                         
    # ---------------------------------------------------------------------------------------------
    print('=' *33)          
    print('(Step 32C/33) OF BUFFER4XI5TEST - TRYING TO CREATE SUB-BUFFERS ', time4xi()) 
    print('=' *33)      
    try:
        create2subbuffer = cc2xi.create2subbuffer(task4create2subbuffer)
    
        print('=' *33)          
        print('(Step 32D/33) OF BUFFER4XI5TEST - CREATED SUB-BUFFERS: ', create2subbuffer)  
        # {'VPU': {'CODE2ERROR': 0,
        #   'COUNT2REFERENCE': 0, 
        #   'BUFFER': {'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003FA5EF0>, 'ACK2RETURN': ' 13B-15B-16B-17B-', 'NACK2RETURN': ' 11Z1-12Z1-14Z1-18Z1-19Z1-',
        #  'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 06:25:43 05/24/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003AF1DC8>,
        #  'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-', 'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1,
        #  'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 'FLAGS': 0, 'SIZE': 33792}, 'POINTER2BUFFER': <arena4xi.Arena4Xi object at 0x0000000003FA5EF0>,
        #  'FLAGS': 0, 'CONTEXT': {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2context4vpu-failed ; time: 06:25:43 05/24/11 Pacific Daylight Time}',
        #  'CLASS': 'create2context4vpu', 'METHOD': 'create2context4vpu'}, 'FUNCTION2CALLBACK': <function trace2context4vpu at 0x0000000003AF1DC8>, 'ACK2RETURN': ' 2A-2C-2D-2E-2B-3B-4B-5B-6B-7B-7B-',
        #  'INFO2PRIVATE': None, 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ',
        #  'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 
        #          'OFFSET': 8192, 'NACK2RETURN': ' 11Z1-12Z1-14Z1-', 'ACK2RETURN': ' 13B-15B-16B-17B-18B-19B-20B-21B-22B-',
        #          'TYPE': 'REGION', 
        #          'SIZE': 4224}, 
        
        print('=' *33)
    except:
        print('(Step 32Z2/33) OF BUFFER4XI5TEST *** FAILED TO CREATE SUB-BUFFERS ', time4xi())                     
         
        
                                                                                                          
    # ---------------------------------------------------------------------------------------------
    # SENSE BUFFERS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33A/33) OF BUFFER4XI5TEST - SENSING ', time4xi())
    print('=' *33)      
    
    try:
        print(cc2xi.sense())
    
        print('=' *33)          
        print('(Step 33B/33) OF BUFFER4XI5TEST - SENSED ', time4xi()) 
        # SENSED  06:09:15 06/07/11 Pacific Daylight Time
        
        print('=' *33)
    except:
        print('(Step 33Z1/33) OF BUFFER4XI5TEST *** FAILED TO SENSE ', time4xi())          
        
    # ---------------------------------------------------------------------------------------------
    # REASON BUFFERS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33C/33) OF BUFFER4XI5TEST - REASONING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.reason())
    
        print('=' *33)          
        print('(Step 33D/33) OF BUFFER4XI5TEST - REASONED ', time4xi())
        # 06:09:15 06/07/11 Pacific Daylight Time
        
        print('=' *33)       
    except:
        print('(Step 33Z2/33) OF BUFFER4XI5TEST *** FAILED TO REASON ', time4xi())                                   
             
    # ---------------------------------------------------------------------------------------------
    # ACE BUFFERS                           
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33E/33) OF BUFFER4XI5TEST - ACING ', time4xi())
    print('=' *33)       
    
    try:
        print(cc2xi.ace())
    
        print('=' *33)          
        print('(Step 33F/33) OF BUFFER4XI5TEST - ACED ', time4xi())                                                 
        # 06:09:15 06/07/11 Pacific Daylight Time
        
        print('=' *33) 
    except:
        print('(Step 33Z3/33) OF BUFFER4XI5TEST *** FAILED TO ACE ', time4xi())                                       
     
    # ---------------------------------------------------------------------------------------------
    # DONE                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 33/33) OF BUFFER4XI5TEST - DONE! ', time4xi())
    #                                         
    print('=' *33)
     
          
    #</function4xi>            
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for buffer4xi5test
#"> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; ACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():
    global trace2scope
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    trace2scope = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    print('=' *33)
    print("(Step 0A/700) OF BUFFER4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi()) 
    # 
    print('=' *33)
    try:            

        buffer4xi5test()  
        
        print('=' *33)
        print("(Step 0B/33) OF BUFFER4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi()) 
        #            
        print('=' *33) 
    except:
        pass
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(trace2scope)                               
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# buffer4xi5test.txt
# sense-buffer4xi5test.xml
# reason-buffer4xi5test.xml
# ace-buffer4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of buffer4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
